/*
 *	Copyright  1991 by S.R.
 *
 *	Created: 23 Jan 1994
 *	Modified:	06 Jun 1994	23:12:19
 *
 * Make>> smake
 */

//#undef DEBUG
#include "/Debug.h"

#include "/File-HandlerClass.h"
#include "/File-Handler_pragmas.h"
#include "/File-Handler_protos.h"

#include "/Tar-FileHandlerClass.h"
#include "Tar-FileHandler.h"

#include "proto/OM_New.h"
#include "proto/OM_Dispose.h"
#include "proto/OM_Get.h"
#include "proto/OM_Set.h"
#include "proto/OM_Update.h"
#include "proto/FHM_DoPacket.h"
#include "proto/Misc.h"
#include "proto/TarObject.h"

#include "TarObject.h"

#define ANYTHING 0x23051994

extern struct IntuitionBase *IntuitionBase;
extern struct DosLibrary *DOSBase;
extern struct Library *FileHandlerBase;

static ULONG DoFHAM_Packet_STARTUP( Class *Cl, Object *O, struct fhpDoPacket *fhpDoPacket, struct TarFileHandlerData * const Data)
{
	ULONG RC = NULL;	/* generic return value, meaning depend on the method */

	DBG_Trace();
	switch( fhpDoPacket->fhpdp_AsyncWork.fhpaw_State)
		{
			case FHPState_Initial:
				{
					if ( RC = DoSuperMethodA( Cl, O, (Msg)fhpDoPacket))
						{
							struct fhpAsyncRW *fhpAsyncRW;

							if ( fhpAsyncRW = AllocVec( sizeof( struct fhpAsyncRW) + 1024L, MEMF_PUBLIC))	/* MEMF_PUBLIC because it is a buffer memory wich can be shared between multiple process */
								{
									fhpDoPacket->fhpdp_AsyncWork.fhpaw_Data = fhpAsyncRW;
									fhpAsyncRW->fhparw_AsyncWork.MethodID = FHAM_AsyncRead;
									fhpAsyncRW->fhparw_Pos = 0;
									fhpAsyncRW->fhparw_Len = 1024;
									fhpAsyncRW->fhparw_Mem = (UBYTE *)(fhpAsyncRW + sizeof( fhpAsyncRW));
									if ( StartAsyncMethod( O, fhpDoPacket, fhpAsyncRW))
										{
											return TRUE;
										}
									FreeVec( fhpAsyncRW);
								}
						}
					return FALSE;
				}
				break;
			case FHPState_ReturnFromHostFS:
				{
					switch( fhpDoPacket->fhpdp_AsyncWork.fhpaw_Count)
						{
							case 1:
								{
									/* return from FHM_AsyncRW() */
									struct fhpAsyncRW *fhpAsyncRW;

									fhpAsyncRW = fhpDoPacket->fhpdp_AsyncWork.fhpaw_Data;
									fhpDoPacket->fhpdp_AsyncWork.fhpaw_Data = NULL;

									/* failure or succes, job is finished */
									fhpDoPacket->fhpdp_AsyncWork.fhpaw_State = FHPState_AsyncWorkFinished;

									if ( fhpAsyncRW->fhparw_AsyncWork.fhpaw_RC != -1)
										{
											/* can't do this: this method can't be called from the handler ( dos limitation) */
											/* temporary removed the limitation */
											RC = DoMethod( O,
												FHM_MakeVolumeNode, ITEMIGNORED,
												//FHP_StrPtr, fhpAsyncRW->fhparw_Mem,	/* a \0 must be put at the end og the name */
												FHP_StrPtr, "Tar",
												TAG_END);

											/* tmp: don't free fhpAsyncRW because it hold the Volume name */

											fhpDoPacket->fhpdp_DosPacket->dp_Res1 = DOSTRUE;
											fhpDoPacket->fhpdp_DosPacket->dp_Res2 = 0;
											return TRUE;
										}

									fhpDoPacket->fhpdp_DosPacket->dp_Res1 = fhpAsyncRW->fhparw_AsyncWork.fhpaw_RC;
									fhpDoPacket->fhpdp_DosPacket->dp_Res2 = fhpAsyncRW->fhparw_AsyncWork.fhpaw_Error;
									FreeVec( fhpAsyncRW);
									return FALSE;
								}
								break;
							default:
								DBG_Error( KPrintF("%s, %s(), %l04d>E:\0x07Unknown fhpDoPacket state Count:%ld\n", __FILE__, __FUNC__, __LINE__, (LONG)fhpDoPacket->fhpdp_AsyncWork.fhpaw_Count));
								break;
						}
				}
			break;
			default:
				DBG_Error( KPrintF("%s, %s(), %l04d>E:Unknown fhpDoPacket state:%ld\n", __FILE__, __FUNC__, __LINE__, (LONG)fhpDoPacket->fhpdp_AsyncWork.fhpaw_State));
				break;
		}

	return RC;
}


static ULONG DoFHAM_Packet_DISK_INFO( Class *Cl, Object *O, struct fhpDoPacket *fhpDoPacket, struct TarFileHandlerData * const Data)
{
	struct DosPacket *DosPacket;
	struct InfoData *InfoData;

	DBG_Trace();

	DosPacket = (struct DosPacket *)fhpDoPacket->fhpdp_DosPacket;

	switch( fhpDoPacket->fhpdp_AsyncWork.fhpaw_State)
		{
			case FHPState_Initial:
				{
					struct DosPacket *ServicePacket;

					if ( ServicePacket = AllocDosObject( DOS_STDPKT, NULL))	/* Dos will allocate the struct and init it, It is not exactly a DosPacket but you can quietly forget it */
						{
							fhpDoPacket->fhpdp_AsyncWork.fhpaw_Data = ServicePacket; 
							ServicePacket->dp_Type = ACTION_DISK_INFO;
							ServicePacket->dp_Arg1 = DosPacket->dp_Arg1;	/* I reuse the orginal InfoData to Avoid etra AllocMem() */
							if ( DoMethod( O,
									FHM_AddAndSendAWaitingServicePacket, ITEMIGNORED,
									FHP_Packet, ServicePacket,
									FHP_AsyncWork, fhpDoPacket,
									TAG_END)
								)
								return TRUE;
							else
								return FALSE;
						}
					else
						{
							fhpDoPacket->fhpdp_AsyncWork.fhpaw_State = FHPState_AsyncWorkFinished;
							DosPacket->dp_Res1 = DOSFALSE;
							DosPacket->dp_Res2 = ERROR_NO_FREE_STORE;
							return FALSE;
						}
				}
				break;
			case FHPState_ReturnFromHostFS:
				{
					switch( fhpDoPacket->fhpdp_AsyncWork.fhpaw_Count)
						{
							case 1:
								{
									struct InfoData HFSInfoData;

									/* return from the Info-Packet */
									/* the InfoData was filled in by the Host FileSystem so, only modfiy necessary field */
									InfoData = BADDR( DosPacket->dp_Arg1);
									HFSInfoData = *InfoData;	/* save HFS InfoData because SuperMethod use the InfoData (normal procedure) */

									FreeDosObject( DOS_STDPKT, fhpDoPacket->fhpdp_AsyncWork.fhpaw_Data);
									fhpDoPacket->fhpdp_AsyncWork.fhpaw_Data = NULL;

									DoSuperMethodA( Cl, O, (Msg)fhpDoPacket);

									InfoData->id_NumSoftErrors = HFSInfoData.id_NumSoftErrors;
									// SuperClass managment: InfoData->id_UnitNumber = 0;
									InfoData->id_DiskState = ID_WRITE_PROTECTED;				/* for this Tar Handler, we can't write */
									InfoData->id_NumBlocks = HFSInfoData.id_NumBlocks;
									InfoData->id_NumBlocksUsed = HFSInfoData.id_NumBlocksUsed;
									InfoData->id_BytesPerBlock = HFSInfoData.id_BytesPerBlock;
									InfoData->id_DiskType = ID_DOS_DISK;
									// SuperClass managment: InfoData->id_VolumeNode = MKBADDR( Data->VolumeNode);
									InfoData->id_InUse = 0;	/* not in use */

									fhpDoPacket->fhpdp_AsyncWork.fhpaw_State = FHPState_AsyncWorkFinished;
									DosPacket->dp_Res1 = DOSTRUE;
									DosPacket->dp_Res2 = 0;

									return TRUE;
								}
								break;
							default:
								DBG_Error( KPrintF("%s, %s(), %l04d>E:\0x07Unknown fhpDoPacket state Count:%ld\n", __FILE__, __FUNC__, __LINE__, (LONG)fhpDoPacket->fhpdp_AsyncWork.fhpaw_Count));
								break;
						}
				}
			break;
			default:
				{
					DBG_Error( KPrintF("%s, %s(), %l04d>E:\0x07Unknown fhpDoPacket state:%ld\n", __FILE__, __FUNC__, __LINE__, (LONG)fhpDoPacket->fhpdp_AsyncWork.fhpaw_State));
					DPReturn( fhpDoPacket, FALSE, 0, FALSE, 1, DOSFALSE, ERROR_NOT_A_DOS_DISK);	/* no better msg */
				}
				break;
		}
}


LONG CanLock( struct TarObject *TarObject, LONG Access)
{
	switch( TarObject->Access)
		{
			case 0:
				{
					/* no access for this object, so all type of lock are permited */
					return NULL;
				}
				break;
			case SHARED_LOCK:
				{
					switch ( Access)
						{
							case SHARED_LOCK:
								{
									return NULL;
								}
								break;
							case EXCLUSIVE_LOCK:
								{
									return ERROR_OBJECT_IN_USE;
								}
								break;
							default:
								return ERROR_INVALID_LOCK;
						}

				}
				break;
			case EXCLUSIVE_LOCK:
				{
					return ERROR_OBJECT_IN_USE;
				}
				break;
			default:
				{
					DBG_Error( KPrintF("%s, %s(), %l04d>E:invalid internal access lock:%l08x\n", __FILE__, __FUNC__, __LINE__, (LONG)TarObject->Access));
					return ERROR_INVALID_LOCK;
				}
		}
}


/* It is a procedure wich make the public/dos lock corresponding to the passed Tar Object.
	TERMINATE the ASyncMethod
 */
static ULONG TarLock( Object *O, struct fhpDoPacket *fhpDoPacket, struct TarObject *TarObject, LONG Access)
{
	switch( TarObject->Access)
		{
			case 0:
				{
					/* no access for this object, so all type of lock are permited */
					struct FileLock *FileLock;

					if ( FileLock = (struct FileLock *)DoMethod( O, FHM_NewFileLock, ITEMIGNORED, FHP_Data, TarObject, FHP_Access, Access, TAG_END))
						{
							TarObject->Access = Access;
							TarObject->AccessCnt++;

							DPReturn( fhpDoPacket, TRUE, 0, TRUE, 0, MKBADDR( FileLock), ANYTHING);
						}
					else
						DPReturn( fhpDoPacket, TRUE, 0, TRUE, 0, DOSFALSE, ERROR_NO_FREE_STORE);
				}
				break;
			case SHARED_LOCK:
				{
					switch ( Access)
						{
							case SHARED_LOCK:
								{
									struct FileLock *FileLock;

									if ( FileLock = (struct FileLock *)DoMethod( O, FHM_NewFileLock, ITEMIGNORED, FHP_Data, TarObject, FHP_Access, SHARED_LOCK, TAG_END))	//NewFileLock( TarObject, SHARED_LOCK, Data->, Data->))
										{
											TarObject->Access = SHARED_LOCK;
											TarObject->AccessCnt++;

											DPReturn( fhpDoPacket, TRUE, 0, TRUE, 0, MKBADDR( FileLock), ANYTHING);
										}
									else
										DPReturn( fhpDoPacket, TRUE, 0, TRUE, 0, DOSFALSE, ERROR_NO_FREE_STORE);
								}
								break;
							case EXCLUSIVE_LOCK:
								{
									DPReturn( fhpDoPacket, TRUE, 0, TRUE, 0, DOSFALSE, ERROR_OBJECT_IN_USE);
								}
								break;
							default:
								DPReturn( fhpDoPacket, FALSE, 0, FALSE, 1, DOSFALSE, ERROR_INVALID_LOCK);	/* no better msg */
						}

				}
				break;
			case EXCLUSIVE_LOCK:
				{
					DPReturn( fhpDoPacket, TRUE, 0, TRUE, 0, DOSFALSE, ERROR_OBJECT_IN_USE);
				}
				break;
			default:
				{
					DBG_Error( KPrintF("%s, %s(), %l04d>E:invalid internal access lock:%l08x\n", __FILE__, __FUNC__, __LINE__, (LONG)TarObject->Access));
					DPReturn( fhpDoPacket, FALSE, 0, FALSE, 1, DOSFALSE, ERROR_INVALID_LOCK);	/* no better msg */
				}
		}
}

static ULONG DoFHAM_Packet_LOCATE_OBJECT( Class *Cl, Object *O, struct fhpDoPacket *fhpDoPacket, struct TarFileHandlerData * const Data)
{
	struct DosPacket *DosPacket;

	/*
		dp_Arg1: BPTR to struct FileLock of parent
		dp_Arg2: BPTR to BSTR of name
		dp_Arg3: LONG access mode

		dp_Res1: BPTR to struc FileLock of object
		dp_Res2: LONG error code (if dp_Res1 == 0)
	*/
	DBG_Trace();

	DosPacket = (struct DosPacket *)fhpDoPacket->fhpdp_DosPacket;

	DosPacket->dp_Res1 = DOSFALSE;
	DosPacket->dp_Res2 = ERROR_ACTION_NOT_KNOWN;
	switch( fhpDoPacket->fhpdp_AsyncWork.fhpaw_State)
		{
			case FHPState_Initial:
				{
					///* super class fill the fl_Access, fl_Task, fl_Volume field */
					//return DoSuperMethodA( Cl, O, (Msg)fhpDoPacket);
					if ( !Data->Root)
						{
							struct fhpAsyncWork *fhpAsyncWork;

						if ( fhpAsyncWork = AllocVec( sizeof( struct fhpAsyncWork), MEMF_ANY))
							{
								fhpAsyncWork->MethodID = TFHAM_ReadAllDir;
								if ( StartAsyncMethod( O, fhpDoPacket, fhpAsyncWork))
									{
										return TRUE;
									}
						}
					}
				else
					{
						/* nothing to do, just go to next state */
						fhpDoPacket->fhpdp_AsyncWork.fhpaw_Count++;
					}
				}
				/* intentionaly no break */
			case FHPState_ReturnFromHostFS:
				{
					switch( fhpDoPacket->fhpdp_AsyncWork.fhpaw_Count)
						{
							case 1:
								{
									struct TarObject *TarObject;

									if ( TarObject = GetTarObjectFromParentLock( BADDR( DosPacket->dp_Arg1), BADDR( DosPacket->dp_Arg2), Data))
										{
											return TarLock( O, fhpDoPacket, TarObject, DosPacket->dp_Arg3);
										}
									else
										{
											/* object not found */
											DPReturn( fhpDoPacket, FALSE, 0, FALSE, 1, DOSFALSE, ERROR_OBJECT_NOT_FOUND);
										}
								}
								break;
							default:
								DBG_Error( KPrintF("%s, %s(), %l04d>E:\0x07Unknown fhpDoPacket state Count:%ld\n", __FILE__, __FUNC__, __LINE__, (LONG)fhpDoPacket->fhpdp_AsyncWork.fhpaw_Count));
								break;
						}
				}
			break;
			default:
				{
					DBG_Error( KPrintF("%s, %s(), %l04d>E:\0x07Unknown fhpDoPacket state:%ld\n", __FILE__, __FUNC__, __LINE__, (LONG)fhpDoPacket->fhpdp_AsyncWork.fhpaw_State));
					DPReturn( fhpDoPacket, FALSE, 0, FALSE, 1, DOSFALSE, ERROR_NOT_A_DOS_DISK);	/* no better msg */
				}
				break;
		}
}


static ULONG DoFHAM_Packet_EXAMINE_OBJECT( Class *Cl, Object *O, struct fhpDoPacket *fhpDoPacket, struct TarFileHandlerData * const Data)
{
	struct DosPacket *DosPacket;
	struct FileInfoBlock *FileInfoBlock;
	struct FileLock *FileLock;

	/*
		dp_Arg1: BPTR to struct FileLock
		dp_Arg2: BPTR to struct FileInfoBlock to fill in

		dp_Res1: DOSTRUE/DOSFALSE
		dp_Res2: LONG error code (if dp_Res1 == DOSFALSE)
	*/
	DBG_Trace();

	DosPacket = (struct DosPacket *)fhpDoPacket->fhpdp_DosPacket;
	FileLock = (struct FileLock *)BADDR( DosPacket->dp_Arg1);
	FileInfoBlock = (struct FileInfoBlock *)BADDR( DosPacket->dp_Arg2);
	
	switch( fhpDoPacket->fhpdp_AsyncWork.fhpaw_State)
		{
			case FHPState_Initial:
				{
					struct TarObject *TarObject;

					TarObject = (struct TarObject *)FileLock->fl_Key;
					if ( TarObject)
						{
							FileInfoBlock->fib_DiskKey = (LONG)GetHead( (struct MinList *)&TarObject->TarObjectList);
							FileInfoBlock->fib_DirEntryType = TarObject->Type;
							CStrToBStr( TarObject->Name, FileInfoBlock->fib_FileName);
							FileInfoBlock->fib_Protection = 0;	/* tmp */
							FileInfoBlock->fib_EntryType = FileInfoBlock->fib_DirEntryType;	/* as recommended in the GuruBook */
							FileInfoBlock->fib_Size = TarObject->Size;
							FileInfoBlock->fib_NumBlocks = ( TarObject->Size / 512 + 1) + 1;
							//FileInfoBlock->fib_Date = { 0, 0, 0};	/* tmp */
							FileInfoBlock->fib_Comment[0] = '\0';	/* No comment stored in the Tar format */
							FileInfoBlock->fib_OwnerUID = 0;
							FileInfoBlock->fib_OwnerGID = 0;

							DPReturn( fhpDoPacket, TRUE, 0, TRUE, 0, DOSTRUE, ANYTHING);
						}
					else
						{
							/* invalid lock (there are other way to be invalid, but this case are one of them) */
							DPReturn( fhpDoPacket, FALSE, 0, FALSE, 1, DOSFALSE, ERROR_INVALID_LOCK);
						}

				}
			break;
			default:
				{
					DBG_Error( KPrintF("%s, %s(), %l04d>E:\0x07Unknown fhpDoPacket state:%ld\n", __FILE__, __FUNC__, __LINE__, (LONG)fhpDoPacket->fhpdp_AsyncWork.fhpaw_State));
					DPReturn( fhpDoPacket, FALSE, 0, FALSE, 1, DOSFALSE, ERROR_NOT_A_DOS_DISK);	/* no better msg */
				}
				break;
		}
}

static ULONG DoFHAM_Packet_FREE_LOCK( Class *Cl, Object *O, struct fhpDoPacket *fhpDoPacket, struct TarFileHandlerData * const Data)
{
	struct DosPacket *DosPacket;
	struct FileLock *FileLock;

	/*
		dp_Arg1: BPTR to struct FileLock

		dp_Res1: DOSTRUE/DOSFALSE
		dp_Res2: LONG error code (if dp_Res1 == DOSFALSE)
	*/
	DBG_Trace();

	DosPacket = (struct DosPacket *)fhpDoPacket->fhpdp_DosPacket;
	FileLock = (struct FileLock *)BADDR( DosPacket->dp_Arg1);
	
	switch( fhpDoPacket->fhpdp_AsyncWork.fhpaw_State)
		{
			case FHPState_Initial:
				{
					struct TarObject *TarObject;

					if ( FileLock)
						{
							TarObject = (struct TarObject *)FileLock->fl_Key;
							FileLock->fl_Task = NULL;	/* as recommended in GuruBook */
							if ( TarObject)
								{
									TarObject->AccessCnt--;
									switch ( FileLock->fl_Access)
										{
											case SHARED_LOCK:
												{
													if ( TarObject->AccessCnt == 0)
														{
															TarObject->Access = 0;
														}
													FreeVec( FileLock);	/* tmp */
													DPReturn( fhpDoPacket, TRUE, 0, TRUE, 0, DOSTRUE, ANYTHING);
												}
												break;
											case EXCLUSIVE_LOCK:
												{
													if ( TarObject->AccessCnt == 0)
														{
															/* this is normaly always the case since an exclusive lock can be obtain only one at a time */

															FreeVec( FileLock);	/* tmp */
															DPReturn( fhpDoPacket, TRUE, 0, TRUE, 0, DOSTRUE, ANYTHING);
														}
													else
														{
															/* how could this happend ? */
															DPReturn( fhpDoPacket, FALSE, 0, FALSE, 1, DOSFALSE, ERROR_INVALID_LOCK);
														}

												}
												break;
											default:
												DPReturn( fhpDoPacket, FALSE, 0, FALSE, 1, DOSFALSE, ERROR_INVALID_LOCK);
										}
								}
							else
								{
									/* invalid lock (there are other way to be invalid, but this case are one of them) */
									DPReturn( fhpDoPacket, FALSE, 0, FALSE, 1, DOSFALSE, ERROR_INVALID_LOCK);
								}
						}
					else
						{
							/* ZERO(root) lock, do nothing as recommended in GuruBook */
							/* but it is in the strict sense an error of the application */
							DPReturn( fhpDoPacket, TRUE, 0, TRUE, 0, DOSTRUE, ANYTHING);
						}
				}
			break;
			default:
				{
					DBG_Error( KPrintF("%s, %s(), %l04d>E:\0x07Unknown fhpDoPacket state:%ld\n", __FILE__, __FUNC__, __LINE__, (LONG)fhpDoPacket->fhpdp_AsyncWork.fhpaw_State));
					DPReturn( fhpDoPacket, FALSE, 0, FALSE, 1, DOSFALSE, ERROR_NOT_A_DOS_DISK);	/* no better msg */
				}
				break;
		}
}


static ULONG DoFHAM_Packet_COPY_DIR( Class *Cl, Object *O, struct fhpDoPacket *fhpDoPacket, struct TarFileHandlerData * const Data)
{
	struct DosPacket *DosPacket;
	struct FileLock *FileLock;

	/*
		dp_Arg1: BPTR to struct FileLock (original)

		dp_Res1: BPTR to struct FileLock (copy)
		dp_Res2: LONG error code (if dp_Res1 == 0)
	*/
	DBG_Trace();

	DosPacket = (struct DosPacket *)fhpDoPacket->fhpdp_DosPacket;
	FileLock = (struct FileLock *)BADDR( DosPacket->dp_Arg1);
	
	switch( fhpDoPacket->fhpdp_AsyncWork.fhpaw_State)
		{
			case FHPState_Initial:
				{
					struct TarObject *TarObject;

					if ( FileLock)
						{
							TarObject = (struct TarObject *)FileLock->fl_Key;
							if ( TarObject)
								{
									/* tmp: IsValidLock() */
									switch ( FileLock->fl_Access)
										{
											case SHARED_LOCK:
												{
													struct FileLock *NewFileLock;

													if ( NewFileLock = AllocVec( sizeof( struct FileLock), MEMF_PUBLIC))	/* tmp ?? */
														{
															TarObject->AccessCnt++;
															CopyMem( FileLock, NewFileLock, sizeof( struct FileLock));
															DPReturn( fhpDoPacket, TRUE, 0, TRUE, 0, MKBADDR( NewFileLock), ANYTHING);
														}
													else
														DPReturn( fhpDoPacket, TRUE, 0, TRUE, 0, NULL, ERROR_NO_FREE_STORE);
												}
												break;
											case EXCLUSIVE_LOCK:
												{
													DPReturn( fhpDoPacket, TRUE, 0, TRUE, 0, NULL, ERROR_OBJECT_IN_USE);
												}
												break;
											default:
												DPReturn( fhpDoPacket, FALSE, 0, FALSE, 1, NULL, ERROR_INVALID_LOCK);
										}
								}
							else
								{
									/* invalid lock (there are other way to be invalid, but this case are one of them) */
									DPReturn( fhpDoPacket, FALSE, 0, FALSE, 1, DOSFALSE, ERROR_INVALID_LOCK);
								}
						}
					else
						{
							/* ZERO(root) lock, create a normal shared lock on root. */
							DPReturn( fhpDoPacket, TRUE, 0, TRUE, 0, NULL, ERROR_NO_FREE_STORE);	/* tmp */
						}
				}
			break;
			default:
				{
					DBG_Error( KPrintF("%s, %s(), %l04d>E:\0x07Unknown fhpDoPacket state:%ld\n", __FILE__, __FUNC__, __LINE__, (LONG)fhpDoPacket->fhpdp_AsyncWork.fhpaw_State));
					DPReturn( fhpDoPacket, FALSE, 0, FALSE, 1, DOSFALSE, ERROR_NOT_A_DOS_DISK);	/* no better msg */
				}
				break;
		}
}


static ULONG DoFHAM_Packet_PARENT( Class *Cl, Object *O, struct fhpDoPacket *fhpDoPacket, struct TarFileHandlerData * const Data)
{
	struct DosPacket *DosPacket;
	struct FileLock *FileLock;

	/*
		dp_Arg1: BPTR to struct FileLock to get parent of

		dp_Res1: BPTR to struc FileLock (parent lock)
		dp_Res2: LONG error code (if dp_Res1 == 0) with special case.
	*/
	DBG_Trace();

	DosPacket = (struct DosPacket *)fhpDoPacket->fhpdp_DosPacket;
	FileLock = (struct FileLock *)BADDR( DosPacket->dp_Arg1);

	DosPacket->dp_Res1 = DOSFALSE;
	DosPacket->dp_Res2 = ERROR_ACTION_NOT_KNOWN;
	switch( fhpDoPacket->fhpdp_AsyncWork.fhpaw_State)
		{
			case FHPState_Initial:
				{
					struct TarObject *TarObject;
					struct TarObject *ParentTarObject;

					TarObject = (struct TarObject *)FileLock->fl_Key;
					ParentTarObject = TarObject->ParentTarObject;
					if ( ParentTarObject)
						{
							return TarLock( O, fhpDoPacket, ParentTarObject, SHARED_LOCK);
						}
					else
						{
							/* reach the root, so no parent. special return value to indicate this */
							DPReturn( fhpDoPacket, TRUE, 0, TRUE, 0,
								NULL, 0);	/* this two value indicate this is the root wiche have no parent*/
						}
				}
			break;
			default:
				{
					DBG_Error( KPrintF("%s, %s(), %l04d>E:\0x07Unknown fhpDoPacket state:%ld\n", __FILE__, __FUNC__, __LINE__, (LONG)fhpDoPacket->fhpdp_AsyncWork.fhpaw_State));
					DPReturn( fhpDoPacket, FALSE, 0, FALSE, 1, DOSFALSE, ERROR_NOT_A_DOS_DISK);	/* no better msg */
				}
				break;
		}
}


static ULONG DoFHAM_Packet_EXAMINE_NEXT( Class *Cl, Object *O, struct fhpDoPacket *fhpDoPacket, struct TarFileHandlerData * const Data)
{
	struct DosPacket *DosPacket;
	struct FileLock *FileLock;
	struct FileInfoBlock *FileInfoBlock;

	/*
		dp_Arg1: BPTR to struct FileLock
		dp_Arg2: BPTR to struct FileInfoBlock to fill in

		dp_Res1: LONG DOSTRUE/DOSFALSE
		dp_Res2: LONG error code (if dp_Res1 == DOSFALSE)
	*/
	DBG_Trace();

	DosPacket = (struct DosPacket *)fhpDoPacket->fhpdp_DosPacket;
	FileLock = (struct FileLock *)BADDR( DosPacket->dp_Arg1);
	FileInfoBlock = (struct FileInfoBlock *)BADDR( DosPacket->dp_Arg2);

	DosPacket->dp_Res1 = DOSFALSE;
	DosPacket->dp_Res2 = ERROR_ACTION_NOT_KNOWN;
	switch( fhpDoPacket->fhpdp_AsyncWork.fhpaw_State)
		{
			case FHPState_Initial:
				{
					struct TarObject *TarObject;

					TarObject = (struct TarObject *)FileLock->fl_Key;
					if ( (TarObject->Type == ST_USERDIR) || (TarObject->Type == ST_ROOT))
						{
							/*  warn:  the FileInfoBlock->fib_DiskKey MUST be fill
								with the first entry BEFORE the first call to EXAMINE_NEXT,
								this is made by EXAMINE_OBJECT
							*/

							if ( FileInfoBlock->fib_DiskKey)
								{
									/* WARN: this is safe only because the handler are READONLY */
									struct TarObject  *TarObject;

									TarObject = (struct TarObject *)FileInfoBlock->fib_DiskKey;

									FileInfoBlock->fib_DirEntryType = TarObject->Type;
									CStrToBStr( TarObject->Name, FileInfoBlock->fib_FileName);
									FileInfoBlock->fib_Protection = 0;	/* tmp */
									FileInfoBlock->fib_EntryType = FileInfoBlock->fib_DirEntryType;	/* as recommended in the GuruBook */
									FileInfoBlock->fib_Size = TarObject->Size;
									FileInfoBlock->fib_NumBlocks = ( TarObject->Size / 512 + 1) + 1;
									//FileInfoBlock->fib_Date = { 0, 0, 0};	/* tmp */
									FileInfoBlock->fib_Comment[0] = '\0';	/* No comment stored in the Tar format */
									FileInfoBlock->fib_OwnerUID = 0;
									FileInfoBlock->fib_OwnerGID = 0;

									/* prepare an (eventualy) next EXAMINE_NEXT */
									FileInfoBlock->fib_DiskKey = (LONG)GetSucc( (struct MinNode *)TarObject);
									DPReturn( fhpDoPacket, TRUE, 0, TRUE, 0, DOSTRUE, ANYTHING);
								}
							else
								{
									DPReturn( fhpDoPacket, TRUE, 0, TRUE, 0, DOSFALSE, ERROR_NO_MORE_ENTRIES);
								}
						}
					else
						{
							DPReturn( fhpDoPacket, TRUE, 0, TRUE, 0, DOSFALSE, ERROR_OBJECT_WRONG_TYPE);
						}
				}
			break;
			default:
				{
					DBG_Error( KPrintF("%s, %s(), %l04d>E:\0x07Unknown fhpDoPacket state:%ld\n", __FILE__, __FUNC__, __LINE__, (LONG)fhpDoPacket->fhpdp_AsyncWork.fhpaw_State));
					DPReturn( fhpDoPacket, FALSE, 0, FALSE, 1, DOSFALSE, ERROR_NOT_A_DOS_DISK);	/* no better msg */
				}
				break;
		}
}

struct TarFileHandle
{
	struct FileHandle *FileHandle;
	struct TarObject *TarObject;
};

static ULONG DoFHAM_Packet_FINDINPUT( Class *Cl, Object *O, struct fhpDoPacket *fhpDoPacket, struct TarFileHandlerData * const Data)
{
	struct DosPacket *DosPacket;
	struct FileLock *FileLock;
	struct FileHandle *FileHandle;

	/*
		dp_Arg1: BPTR to struct FileHandle
		dp_Arg2: BPTR to struct FileLock
		dp_Arg3: BPTR to BSTR Name

		dp_Res1: LONG DOSTRUE/DOSFALSE
		dp_Res2: LONG error code (if dp_Res1 == DOSFALSE)
	*/
	DBG_Trace();

	DosPacket = (struct DosPacket *)fhpDoPacket->fhpdp_DosPacket;
	FileHandle = (struct FileHandle *)BADDR( DosPacket->dp_Arg1);
	FileLock = (struct FileLock *)BADDR( DosPacket->dp_Arg2);

	DosPacket->dp_Res1 = DOSFALSE;
	DosPacket->dp_Res2 = ERROR_ACTION_NOT_KNOWN;
	switch( fhpDoPacket->fhpdp_AsyncWork.fhpaw_State)
		{
			case FHPState_Initial:
				{
					struct TarObject *TarObject;

					if ( TarObject = GetTarObjectFromParentLock( FileLock, BADDR( DosPacket->dp_Arg3), Data))
						{
							if ( TarObject->Type == ST_FILE)
								{
									LONG Error;

									if ( !(Error = CanLock( TarObject, SHARED_LOCK)))
										{
											struct TarFileHandle *TarFileHandle;

											if ( TarFileHandle = AllocVec( sizeof( struct TarFileHandle), MEMF_ANY))
												{
													TarFileHandle->FileHandle = FileHandle;
													TarFileHandle->TarObject = TarObject;

													FileHandle->fh_Arg1 = (LONG)TarFileHandle;
													TarObject->Access = SHARED_LOCK;
													TarObject->AccessCnt++;

													DPReturn( fhpDoPacket, TRUE, 0, TRUE, 0, DOSTRUE, ANYTHING);
												}
											else
												DPReturn( fhpDoPacket, TRUE, 0, TRUE, 0, NULL, ERROR_NO_FREE_STORE);
										}
									else
										DPReturn( fhpDoPacket, FALSE, 0, FALSE, 1, DOSFALSE, Error);
								}
							else
								DPReturn( fhpDoPacket, FALSE, 0, FALSE, 1, DOSFALSE, ERROR_OBJECT_WRONG_TYPE);
						}
					else
						{
							/* object not found */
							DPReturn( fhpDoPacket, FALSE, 0, FALSE, 1, DOSFALSE, ERROR_OBJECT_NOT_FOUND);
						}
				}
			break;
			default:
				{
					DBG_Error( KPrintF("%s, %s(), %l04d>E:\0x07Unknown fhpDoPacket state:%ld\n", __FILE__, __FUNC__, __LINE__, (LONG)fhpDoPacket->fhpdp_AsyncWork.fhpaw_State));
					DPReturn( fhpDoPacket, FALSE, 0, FALSE, 1, DOSFALSE, ERROR_NOT_A_DOS_DISK);	/* no better msg */
				}
				break;
		}
}



static ULONG DoFHAM_Packet_READ( Class *Cl, Object *O, struct fhpDoPacket *fhpDoPacket, struct TarFileHandlerData * const Data)
{
	struct DosPacket *DosPacket;
	struct TarObject *TarObject;
	void *Buffer;
	LONG ByteToRead;
	struct TarFileHandle;

	/*
		dp_Arg1: FileHandle->fh_Arg1
		dp_Arg2: void *Buffer
		dp_Arg3: LONG ByteToRead

		dp_Res1: LONG byte readed, 0 = EOF, -1 = error
		dp_Res2: LONG error code (if dp_Res1 == -1)
	*/
	DBG_Trace();

	DosPacket = (struct DosPacket *)fhpDoPacket->fhpdp_DosPacket;
	TarObject = (struct TarObject *)BADDR( DosPacket->dp_Arg1);
	TarFileHandle = ( struct TarFileHandle *)BADDR( DosPacket->dp_Arg1);
	Buffer = BADDR( DosPacket->dp_Arg2);
	ByteToRead = (LONG)BADDR( DosPacket->dp_Arg3);

	DosPacket->dp_Res1 = DOSFALSE;
	DosPacket->dp_Res2 = ERROR_ACTION_NOT_KNOWN;
	switch( fhpDoPacket->fhpdp_AsyncWork.fhpaw_State)
		{
			case FHPState_Initial:
				{
					struct fhpAsyncRW *fhpAsyncRW;

					if ( fhpAsyncRW = AllocVec( sizeof( struct fhpAsyncRW) + 1024L, MEMF_PUBLIC))	/* MEMF_PUBLIC because it is a buffer memory wich can be shared between multiple process */
						{
							fhpDoPacket->fhpdp_AsyncWork.fhpaw_Data = fhpAsyncRW;
							fhpAsyncRW->fhparw_AsyncWork.MethodID = FHAM_AsyncRead;
							fhpAsyncRW->fhparw_Pos = TarObject->Offset + TarFileHandle->FileHandle->fh_Pos;
							fhpAsyncRW->fhparw_Len = ByteToRead;
							fhpAsyncRW->fhparw_Mem = Buffer;
							if ( StartAsyncMethod( O, fhpDoPacket, fhpAsyncRW))
								{
									return TRUE;
								}
							FreeVec( fhpAsyncRW);
						}
					DPReturn( fhpDoPacket, FALSE, 0, FALSE, 1, DOSFALSE, ERROR_NOT_A_DOS_DISK);	/* no better msg */
				}
				break;
			case FHPState_ReturnFromHostFS:
				{
					switch( fhpDoPacket->fhpdp_AsyncWork.fhpaw_Count)
						{
							case 1:
								{
									/* return from FHM_AsyncRW() */
									struct fhpAsyncRW *fhpAsyncRW;

									fhpAsyncRW = fhpDoPacket->fhpdp_AsyncWork.fhpaw_Data;
									fhpDoPacket->fhpdp_AsyncWork.fhpaw_Data = NULL;

									if ( fhpAsyncRW->fhparw_AsyncWork.fhpaw_RC != -1)
										{
											ULONG ByteReaded;

											ByteReaded = fhpAsyncRW->fhparw_AsyncWork.fhpaw_RC;
											FreeVec( fhpAsyncRW);
											DPReturn( fhpDoPacket, TRUE, 0, TRUE, 0, ByteReaded, ANYTHING);
										}

									fhpDoPacket->fhpdp_DosPacket->dp_Res1 = fhpAsyncRW->fhparw_AsyncWork.fhpaw_RC;
									fhpDoPacket->fhpdp_DosPacket->dp_Res2 = fhpAsyncRW->fhparw_AsyncWork.fhpaw_Error;

									FreeVec( fhpAsyncRW);

									DPReturn( fhpDoPacket, FALSE, 0, FALSE, 1, fhpDoPacket->fhpdp_DosPacket->dp_Res1, fhpDoPacket->fhpdp_DosPacket->dp_Res2);
								}
								break;
							default:
								DBG_Error( KPrintF("%s, %s(), %l04d>E:\0x07Unknown fhpDoPacket state Count:%ld\n", __FILE__, __FUNC__, __LINE__, (LONG)fhpDoPacket->fhpdp_AsyncWork.fhpaw_Count));
								break;
						}
				}
			break;
			default:
				{
					DBG_Error( KPrintF("%s, %s(), %l04d>E:\0x07Unknown fhpDoPacket state:%ld\n", __FILE__, __FUNC__, __LINE__, (LONG)fhpDoPacket->fhpdp_AsyncWork.fhpaw_State));
					DPReturn( fhpDoPacket, FALSE, 0, FALSE, 1, DOSFALSE, ERROR_NOT_A_DOS_DISK);	/* no better msg */
				}
				break;
		}
}



ULONG DoFHAM_DoPacket( Class *Cl, Object *O, struct fhpDoPacket *fhpDoPacket, struct TarFileHandlerData * const Data)
{
	ULONG RC = NULL;	/* generic return value, meaning depend on the method */

	DBG_Trace();
	switch( fhpDoPacket->fhpdp_DosPacket->dp_Type)
		{
			case ACTION_STARTUP:
				RC = DoFHAM_Packet_STARTUP( Cl, O, fhpDoPacket, Data);
				break;
			case ACTION_DISK_INFO:
				/* This methode MUST be overwrtten */
				RC = DoFHAM_Packet_DISK_INFO( Cl, O, fhpDoPacket, Data);
				break;
			case ACTION_LOCATE_OBJECT:
				RC = DoFHAM_Packet_LOCATE_OBJECT( Cl, O, fhpDoPacket, Data);
				break;
			case ACTION_EXAMINE_OBJECT:
				RC = DoFHAM_Packet_EXAMINE_OBJECT( Cl, O, fhpDoPacket, Data);
				break;
			case ACTION_FREE_LOCK:
				RC = DoFHAM_Packet_FREE_LOCK( Cl, O, fhpDoPacket, Data);
				break;
			case ACTION_COPY_DIR:
				RC = DoFHAM_Packet_COPY_DIR( Cl, O, fhpDoPacket, Data);
				break;
			case ACTION_PARENT:
				RC = DoFHAM_Packet_PARENT( Cl, O, fhpDoPacket, Data);
				break;
			case ACTION_EXAMINE_NEXT:
				RC = DoFHAM_Packet_EXAMINE_NEXT( Cl, O, fhpDoPacket, Data);
				break;
			case ACTION_FINDINPUT:
				RC = DoFHAM_Packet_FINDINPUT( Cl, O, fhpDoPacket, Data);
				break;

			default:
				/* Nothing particular to do for this class, call SuperMethod() */
				RC = DoSuperMethodA( Cl, O, (Msg)fhpDoPacket);
				break;
		}
	return RC;
}
