/*
 *	Copyright  1994 by S.R.
 *
 *	Created: 23 Jan 1994
 *	Modified:	17 Mar 1994	20:10:50
 *
 * Make>> smake
 */

#ifndef FILEHANDLERCLASS_H
#define FILEHANDLERCLASS_H

#define ITEMIGNORED	((ULONG)0x01021970)


/* Method marked by a '(T)' must be called like this:
	DoMethod( Object, FHM_xxx, ITEMIGNORED, Tag1, Item1, Tag2, Item2,..., TAG_END)
	there have no struct 'parameter'
*/
#define FHM_Dummy 							( 0x80000000)
#define FHM_SendAWaitingServicePacket	( FHM_Dummy + 0x01)	/* (T) TAG_END */
#define FHM_AddAWaitingServicePacket	( FHM_Dummy + 0x02)	/* (T) FHP_Packet, struct DosPacket *ServicePacket, FHP_AsyncWork, struct fhpAsyncWork *fhpAsyncWork, TAG_END */
#define FHM_MountDOSDev						( FHM_Dummy + 0x04)	/* (T) FHP_DOSDevName, DOSDevName, TAG_END */
#define FHM_Startup							( FHM_Dummy + 0x05)	/* (T) TAG_END: called at hadnler start to replace the ACTION_STARTUP that dos never send. Yan can't do any FS work before this method */
#define FHM_ReplyPacket						( FHM_Dummy + 0x06)	/* (T) FHP_Packet, DosPacket, TAG_END. Reply a Packet to DOS */
#define FHM_MakeVolumeNode					( FHM_Dummy + 0x07)	/* (T) FHP_StrPtr, Name, [ FHP_DateStamp, VolumeDate,] TAG_END. return FHRC_xxx. Make and link the Volume to the system. VolumeData was copied by method() so you can free it after. Never call this methode in a handler or you can deadlock (but this shouldn't happen) */
#define FHM_AddAndSendAWaitingServicePacket	( FHM_Dummy + 0x08)	/* (T) FHP_Packet, struct DosPacket *ServicePacket, FHP_AsyncWork, struct fhpAsyncWork *fhpAsyncWork, TAG_END */
#define FHM_Handler							( FHM_Dummy + 0x09)	/* (T) TAG_END */
#define FHM_HandleSignal					( FHM_Dummy + 0x0A)	/* (T) FHP_Signal, Signal, TAG_END: Handle signal of the superclass (for example a msg come at pr_MsgPort). There no reason to overwrite this Method */
#define FHM_NewFileLock						( FHM_Dummy + 0x0B)	/* (T) FHP_Data, DataInfl_Key, FHP_Access, Access, TAG_END */

#define FHAM_Dummy							( FHM_Dummy + 0x0100)
#define FHAM_DoPacket						( FHAM_Dummy + 0x01)	/* struct fhpDoPacket *: */
#define FHAM_AsyncRead						( FHAM_Dummy + 0x02)	/* (T) */
#define FHAM_AsyncWrite						( FHAM_Dummy + 0x03)	/* (T) */

/* it is also Parameters Tag for 'taged' method */
#define FHP_Dummy								( TAG_USER + 0x10000000)
#define FHP_Message 							( FHP_Dummy + 0x01)
#define FHP_Packet 							( FHP_Dummy + 0x02)
#define FHP_State			 					( FHP_Dummy + 0x03)		/* ULONG: (default to FHPState_Initial) */
#define FHP_HostFileSystemReplyPort		( FHA_Dummy + 0x04)		/* struct MsgPort: (I) internal. Handler say to the Object the ReplyPort of the HostFileSystem ( used to put in Packet/Message) */
#define FHP_HandlerPort						( FHA_Dummy + 0x05)		/* struct MsgPort: (I) internal. Handler say to the Object his port */
#define FHP_LibraryToClose 				( FHA_Dummy + 0x06)		/* struct Library **Library, TAG_END. the Library ptr will be filled with the library to close after the Dispose() */
#define FHP_StrPtr			 				( FHA_Dummy + 0x07)		/* STRPTR: */
#define FHP_DateStamp		 				( FHA_Dummy + 0x08)		/* struct DateStamp *: default to current Date */
#define FHP_Signal							( FHP_Dummy + 0x09)		/* ULONG: Signal returned by Wait() */
#define FHP_DoPacket							( FHP_Dummy + 0x0A)		/* struct fhpDoPacket *: */

#define FHP_AsyncWork						( FHP_Dummy + 0x0B)		/* */
#define FHP_Buffer							( FHP_Dummy + 0x0C)		/* UBYTE *: */
#define FHP_Pos								( FHP_Dummy + 0x0D)		/* ULONG: pos, default to 0 */
#define FHP_Len								( FHP_Dummy + 0x0E)		/* ULONG: len, default to 512*/

#define FHP_Data								( FHP_Dummy + 0x0F)		/* void *: */
#define FHP_Access							( FHP_Dummy + 0x10)		/* LONG: Access mode */


struct fhpAsyncWork
{
	ULONG MethodID;

	/* Private to fhpAsyncWork management */
	struct AsyncWorkStack *fhpaw_AsyncWorkStack;	/* stack of all data of asyncwork */

	ULONG fhpaw_State;							/* see FHPState_xxx */
	ULONG fhpaw_Count;							/* count for state. An AsyncWork can also use its own internal (perhaps non-linear) state. Anyway fhpaw_State MUST be correclty updated. */
	ULONG fhpaw_Flags;							/* Flags. see below */
	ULONG fhpaw_RC;								/* the final return code, generaly a 'positive' return code ( i.e the pointer on what you ask). This leave the return code of function/method free for success/failure flag */
	ULONG fhpaw_Error;							/* error code. (if any) */

	APTR fhpaw_Data;								/* Data for each method, the method wich use it must clear/free it */
};
#define FHPState_Initial 				1L
#define FHPState_ReturnFromHostFS 	2L
#define FHPState_AsyncWorkFinished	3L	/* this AsyncWork is completly Processed. you can free the corresponding AsyncWork */
#define FHPState_Start					4L	/* first Packet recievd. (normaly an ACTION_START) */

#define FHPF_QuitHandler	0x00000001	/* the Handler has terminated and must die */

struct fhpDoPacket
{
	struct fhpAsyncWork fhpdp_AsyncWork;
	struct TagItem *fhpdp_AttrList;
	struct DosPacket *fhpdp_DosPacket;		/* the DosPacket recieved wich cause this */
};

struct fhpAsyncRW
{
	struct fhpAsyncWork fhparw_AsyncWork;
	ULONG fhparw_Pos;
	ULONG fhparw_Len;
	UBYTE *fhparw_Mem;
};


#define FHA_Dummy 							( TAG_USER + 0x0001000)
#define FHA_RealFileLock 					( FHA_Dummy + 0x01)		/* BPTR: (I) Lock on the file to be transformed into volume */
#define FHA_RootLock							( FHA_Dummy + 0x02)		/* BPTR: (G) Lock on the root of the Pseudo volume */
#define FHA_1									( FHA_Dummy + 0x03)		/* */
#define FHA_WaitMask							( FHA_Dummy + 0x04)		/* ULONG: (G) The SignalMask of the SuperClass, if signal recieved match with it, call the Methode HandleSignal */


#define AMReturn( fhpAsyncWork_, RC, fhpawFlags, fhpawRC, fhpawError)    {\
struct fhpAsyncWork *a;\
a = (struct fhpAsyncWork *)fhpAsyncWork_;\
a->fhpaw_State = FHPState_AsyncWorkFinished;\
a->fhpaw_Flags = fhpawFlags;\
a->fhpaw_RC = fhpawRC;\
a->fhpaw_Error = fhpawError;\
if ( a->fhpaw_Data)\
	DBG_Error( KPrintF("%s, %s(), %l04d>E:fhpaw_Data:%l08x\n", __FILE__, __FUNC__, __LINE__, a->fhpaw_Data););\
return RC;\
}

#define DPReturn( fhpDoPacket, RC, fhpawFlags, fhpawRC, fhpawError, dpRes1, dpRes2)    {\
fhpDoPacket->fhpdp_DosPacket->dp_Res1 = dpRes1;\
fhpDoPacket->fhpdp_DosPacket->dp_Res2 = dpRes2;\
AMReturn( fhpDoPacket, RC, fhpawFlags, fhpawRC, fhpawError)\
}

#endif /* FILEHANDLERCLASS_H */
