/*
 *	Copyright  1991 by S.R.
 *
 *	Created: 23 Jan 1994
 *	Modified:	21 May 1994	19:21:00
 *
 * Make>> smake
 */

#include "/Debug.h"

#include "/File-HandlerClass.h"
#include "File-Handler.h"

#include "proto/ASyncReadWrite.h"

struct AsyncReadData
{
	struct DosPacket *SeekServicePacket;
	struct DosPacket *ReadServicePacket;
};

BOOL DoFHAM_AsyncRead( Class *Cl, Object *O, struct fhpAsyncRW *fhpAsyncRW, struct FileHandlerData * const Data)
{
	BOOL RC = FALSE;

	switch( fhpAsyncRW->fhparw_AsyncWork.fhpaw_State)
		{
			case FHPState_Initial:
				{
					struct AsyncReadData *AsyncReadData;

					if ( AsyncReadData = AllocVec( sizeof( struct AsyncReadData), MEMF_ANY))
						{
							/* This two packet MUST be sequential, this is why I send it both now */
							if ( AsyncReadData->SeekServicePacket = AllocDosObject( DOS_STDPKT, NULL))	/* Dos will allocate the struct and init it, It is not exactly a DosPacket but you can quietly forget it */
								{
									AsyncReadData->SeekServicePacket->dp_Type = ACTION_SEEK;
									AsyncReadData->SeekServicePacket->dp_Arg1 = Data->RealFileHandle->fh_Arg1;
									AsyncReadData->SeekServicePacket->dp_Arg2 = fhpAsyncRW->fhparw_Pos;
									AsyncReadData->SeekServicePacket->dp_Arg3 = OFFSET_BEGINNING;
									
									if ( AsyncReadData->ReadServicePacket = AllocDosObject( DOS_STDPKT, NULL))	/* Dos will allocate the struct and init it, It is not exactly a DosPacket but you can quietly forget it */
										{
											AsyncReadData->ReadServicePacket->dp_Type = ACTION_READ;
											AsyncReadData->ReadServicePacket->dp_Arg1 = Data->RealFileHandle->fh_Arg1;
											AsyncReadData->ReadServicePacket->dp_Arg2 = (LONG)fhpAsyncRW->fhparw_Mem;
											AsyncReadData->ReadServicePacket->dp_Arg3 = fhpAsyncRW->fhparw_Len;

											fhpAsyncRW->fhparw_AsyncWork.fhpaw_Data = AsyncReadData;

											RC = DoMethod( O,
												FHM_AddAndSendAWaitingServicePacket, ITEMIGNORED,
												FHP_Packet, AsyncReadData->SeekServicePacket,
												FHP_AsyncWork, fhpAsyncRW,
												TAG_END);
											if ( RC)
												{
													RC = DoMethod( O,
														FHM_AddAndSendAWaitingServicePacket, ITEMIGNORED,
														FHP_Packet, AsyncReadData->ReadServicePacket,
														FHP_AsyncWork, fhpAsyncRW,
														TAG_END);
													if ( RC)
														return TRUE;
												}
										}
									FreeDosObject( DOS_STDPKT, AsyncReadData->SeekServicePacket);
								}
							FreeVec( AsyncReadData);
							fhpAsyncRW->fhparw_AsyncWork.fhpaw_Data = NULL;
						}
					AMReturn( fhpAsyncRW, FALSE, 0, FALSE, 1);
				}
				break;
			case FHPState_ReturnFromHostFS:
				{
					switch( fhpAsyncRW->fhparw_AsyncWork.fhpaw_Count)
						{
							case 1:	/* return from Seek */
								{
									struct AsyncReadData *AsyncReadData;

									AsyncReadData = fhpAsyncRW->fhparw_AsyncWork.fhpaw_Data;

									fhpAsyncRW->fhparw_AsyncWork.fhpaw_RC = AsyncReadData->SeekServicePacket->dp_Res1;
									fhpAsyncRW->fhparw_AsyncWork.fhpaw_Error = AsyncReadData->SeekServicePacket->dp_Res2;
									if ( fhpAsyncRW->fhparw_AsyncWork.fhpaw_RC == -1L)
										{
											FreeDosObject( DOS_STDPKT, AsyncReadData->SeekServicePacket);
											FreeDosObject( DOS_STDPKT, AsyncReadData->ReadServicePacket);
											FreeVec( AsyncReadData);
											fhpAsyncRW->fhparw_AsyncWork.fhpaw_Data = NULL;

											AMReturn( fhpAsyncRW, FALSE, 0, fhpAsyncRW->fhparw_AsyncWork.fhpaw_RC, fhpAsyncRW->fhparw_AsyncWork.fhpaw_Error);
										}
									else
										;	/* nothing to do, just let the work continue */
								}
								break;
							case 2:	/* return from read, AsyncRead is finished */
								{
									struct AsyncReadData *AsyncReadData;

									AsyncReadData = fhpAsyncRW->fhparw_AsyncWork.fhpaw_Data;

									fhpAsyncRW->fhparw_Pos += AsyncReadData->ReadServicePacket->dp_Res1;	/* like the dos Read() */

									fhpAsyncRW->fhparw_AsyncWork.fhpaw_RC = AsyncReadData->ReadServicePacket->dp_Res1;
									fhpAsyncRW->fhparw_AsyncWork.fhpaw_Error = AsyncReadData->ReadServicePacket->dp_Res2;
									FreeDosObject( DOS_STDPKT, AsyncReadData->SeekServicePacket);
									FreeDosObject( DOS_STDPKT, AsyncReadData->ReadServicePacket);
									FreeVec( AsyncReadData);
									fhpAsyncRW->fhparw_AsyncWork.fhpaw_Data = NULL;

									AMReturn( fhpAsyncRW, TRUE, 0, fhpAsyncRW->fhparw_AsyncWork.fhpaw_RC, fhpAsyncRW->fhparw_AsyncWork.fhpaw_Error);
								}
								break;
							default:
								DBG_Error( KPrintF("%s, %s(), %l04d>E:\0x07Unknown fhpDoPacket state Count:%ld\n", __FILE__, __FUNC__, __LINE__, (LONG)fhpAsyncRW->fhparw_AsyncWork.fhpaw_Count));
								break;
						}
				}
			break;
			default:
				DBG_Error( KPrintF("%s, %s(), %l04d>E:\0x07Unknown fhpDoPacket state:%ld\n", __FILE__, __FUNC__, __LINE__, (LONG)fhpAsyncRW->fhparw_AsyncWork.fhpaw_State));
				break;
		}

	return FALSE;
}

ULONG DoFHAM_AsyncWrite( Class *Cl, Object *O, struct fhpAsyncRW *fhpAsyncRW, struct FileHandlerData * const Data)
{
	ULONG RC = NULL;

	return RC;
}
