/*
 *	Copyright  1991 by S.R.
 *
 *	Created: 26 Aug 1993	17:27:34
 *	Modified:	01 May 1994	15:56:12
 *
 * Make>> smake
 */

#include "/Debug.h"

#include "/File-HandlerClass.h"
#include "proto/AsyncWork.h"
#include "proto/Misc.h"

struct AsyncWorkStack
{
	struct MinList Stack;
};

struct AsyncWorkItem
{
	struct MinNode MinNode;
	struct fhpAsyncWork *fhpAsyncWork;
};

static struct AsyncWorkStack *AsyncWorkStack_Build( void)
{
	struct AsyncWorkStack *AsyncWorkStack;

	if ( AsyncWorkStack = AllocVec( sizeof( struct AsyncWorkStack), MEMF_ANY))
		{
			NewMinList( &AsyncWorkStack->Stack);
			return AsyncWorkStack;
		}
}

static void AsyncWorkStack_UnBuild( struct AsyncWorkStack *AsyncWorkStack)
{
	FreeVec( AsyncWorkStack);
}


static BOOL fhpAsyncWork_Push( struct fhpAsyncWork *fhpAsyncWork)
{
	struct AsyncWorkItem *AsyncWorkItem;

	if ( AsyncWorkItem = AllocVec( sizeof( struct AsyncWorkStack), MEMF_ANY))
		{
			AsyncWorkItem->fhpAsyncWork = fhpAsyncWork;
			AddHead( (struct List *)&(fhpAsyncWork->fhpaw_AsyncWorkStack->Stack), (struct Node *)AsyncWorkItem);
			return TRUE;
		}

	return FALSE;
}

/* return old top (the poped fhpAsyncWork) */
static struct fhpAsyncWork *fhpAsyncWork_Pop( struct fhpAsyncWork *fhpAsyncWork)
{
	struct AsyncWorkItem *AsyncWorkItem;
	struct fhpAsyncWork *PopedfhpAsyncWork = NULL;

	if ( AsyncWorkItem = ( struct AsyncWorkItem *)RemHead( (struct List *)&fhpAsyncWork->fhpaw_AsyncWorkStack->Stack))
		{
			PopedfhpAsyncWork = AsyncWorkItem->fhpAsyncWork;
			FreeVec( AsyncWorkItem);
		}

	return PopedfhpAsyncWork;
}

/* return the First fhpAsyncWork if all (stacked) work are finished, NULL otherwise */
struct fhpAsyncWork * __saveds __asm ContinueAsyncMethod( register __a0 Object *O, register __a1 struct fhpAsyncWork *fhpAsyncWork)
{
	DBG_Trace();
	DoMethodA( O, fhpAsyncWork);
	DBG_Trace();
	if ( fhpAsyncWork->fhpaw_State == FHPState_AsyncWorkFinished)
		{
			if ( IsListEmpty( (struct List*)&fhpAsyncWork->fhpaw_AsyncWorkStack->Stack))
				{
					/* all (stacked) work are now finished */
					AsyncWorkStack_UnBuild( fhpAsyncWork->fhpaw_AsyncWorkStack);
					fhpAsyncWork->fhpaw_AsyncWorkStack = NULL;

					return fhpAsyncWork;
				}
			else
				{
					struct fhpAsyncWork *ParentfhpAsyncWork;

					/* this fhpAsyncWork had finished, but there are previous one which are not,
						 so we can go back to the caller */

					if ( ParentfhpAsyncWork = fhpAsyncWork_Pop( fhpAsyncWork))
						{
							/* it is the responsability of the ParentfhpAsyncWork to handle 
								is child fhpAsyncWork. ( usualy this means retrive it, check return code
								and free it.
							*/
							return ContinueAsyncMethod( O, ParentfhpAsyncWork);
						}
					else
						{
							/* due to the if( IsListEmpty()), this can't happend */
						}
				}
		}
	else
		{
			/* the work are not finished so do nothing: the work can continue when the Handler
				recieved another packet replayed from the HostFS
			*/
			fhpAsyncWork->fhpaw_Count++;
			fhpAsyncWork->fhpaw_State = FHPState_ReturnFromHostFS;

			return NULL;
		}
}


BOOL __saveds __asm StartAsyncMethod( register __a0 Object *O, register __a1 struct fhpAsyncWork *ParentfhpAsyncWork, register __a2 struct fhpAsyncWork *fhpAsyncWork)
{

	DBG_Trace();
	#ifdef DEBUG
		if ( !O)
			{
				DBG_Error( KPrintF("%s, %s(), %l04d>E:Object:%lx\n", __FILE__, __FUNC__, __LINE__, (LONG)O));
				return FALSE;
			}
	#endif

	fhpAsyncWork->fhpaw_State = FHPState_Initial;
	fhpAsyncWork->fhpaw_Count = 0;
	fhpAsyncWork->fhpaw_Flags = 0;
	fhpAsyncWork->fhpaw_RC = 0;
	fhpAsyncWork->fhpaw_Error = 0;
	fhpAsyncWork->fhpaw_Data = NULL;	/* this data of child wiich are not yed executed so this should be NULL */

	if ( !ParentfhpAsyncWork)
		{
			/* Ok it is a completly new stack of fhpAsyncWork */
			if ( fhpAsyncWork->fhpaw_AsyncWorkStack = AsyncWorkStack_Build())
				{
					ContinueAsyncMethod( O, fhpAsyncWork);
					return TRUE;
				}
			else
				return FALSE;
		}
	else
		{
			/* Well, we add an fhpAsyncWork to an existing one */
			fhpAsyncWork->fhpaw_AsyncWorkStack = ParentfhpAsyncWork->fhpaw_AsyncWorkStack;
			if ( fhpAsyncWork_Push( ParentfhpAsyncWork))
				{
					ContinueAsyncMethod( O, fhpAsyncWork);
					return TRUE;
				}
			else
				return FALSE;
		}
}
