/*
 *	Copyright  1991 by S.R.
 *
 *	Created: 23 Jan 1994
 *	Modified:	22 May 1994	11:10:41
 *
 * Make>> smake
 */

//#undef DEBUG
#include "/Debug.h"

#include "/File-HandlerClass.h"
#include "File-Handler.h"
#include "Handler.h"

#include "proto/OM_New.h"
#include "proto/OM_Dispose.h"
#include "proto/OM_Get.h"
#include "proto/OM_Set.h"
#include "proto/OM_Update.h"
#include "proto/FHM_DoPacket.h"
#include "proto/Misc.h"

extern struct IntuitionBase *IntuitionBase;
extern struct DosLibrary *DOSBase;

static ULONG DoFHAM_Packet_STARTUP( Class *Cl, Object *O, struct fhpDoPacket *fhpDoPacket, struct FileHandlerData * const Data)
{
	struct DosPacket *DosPacket;

	DBG_Trace();
	DosPacket = fhpDoPacket->fhpdp_DosPacket;
	if ( DosPacket)
		{
			struct FileSysStartupMsg *FileSysStartupMsg;

			Data->DevNode = BADDR( DosPacket->dp_Arg3);
			FileSysStartupMsg = (struct FileSysStartupMsg *)BADDR( Data->DevNode->dn_Startup);

			/*							
			 * Loading DevNode->dn_Task causes DOS *NOT* to startup a new
			 * instance of the device driver for every reference.	E.G. if
			 * you were writing a CON: device you would want this field to be
			 * NULL.
			 */
			Data->DevNode->dn_Task = Data->HandlerPort;

			DosPacket->dp_Res1 = DOSFALSE;	/* Force subclass to Overwrite this method */
			DosPacket->dp_Res2 = ERROR_ACTION_NOT_KNOWN;
			return TRUE;
		}
	else
		{
			DBG_Error( KPrintF("%s, %s(), %l04d>Error:0x07 DosPacket:%l08x, HostFileSystemReplyPort:%l08x, HostFileSystemPort:%l08x, HandlerPort:%l08x\n", __FILE__, __FUNC__, __LINE__, DosPacket, Data->HostFileSystemReplyPort, Data->HostFileSystemPort, Data->HandlerPort););
			DosPacket->dp_Res1 = DOSFALSE;
			DosPacket->dp_Res2 = 0;
			return FALSE;
		}
}

static ULONG DoFHAM_Packet_UNKNOWN( Class *Cl, Object *O, struct fhpDoPacket *fhpDoPacket, struct FileHandlerData * const Data)
{
	struct DosPacket *DosPacket;

	DBG_Trace();
	DosPacket = fhpDoPacket->fhpdp_DosPacket;


	DPReturn( fhpDoPacket, TRUE, 0, TRUE, 0, DOSFALSE, ERROR_ACTION_NOT_KNOWN);
}

static ULONG DoFHAM_Packet_DISK_INFO( Class *Cl, Object *O, struct fhpDoPacket *fhpDoPacket, struct FileHandlerData * const Data)
{
	struct DosPacket *DosPacket;
	struct InfoData *InfoData;

	#ifdef DEBUG
	DBG_Trace();
	DosPacket = (struct DosPacket *)fhpDoPacket->fhpdp_DosPacket;

	InfoData = BADDR( DosPacket->dp_Arg1);
	InfoData->id_NumSoftErrors = 0;	/* just to test it */
	InfoData->id_UnitNumber = 0;
	InfoData->id_DiskState = ID_WRITE_PROTECTED;
	InfoData->id_NumBlocks = 1;
	InfoData->id_NumBlocksUsed = 1;
	InfoData->id_BytesPerBlock = 512;
	InfoData->id_DiskType = ID_NOT_REALLY_DOS;
	InfoData->id_VolumeNode = MKBADDR( Data->VolumeNode);
	InfoData->id_InUse = 0;	/* not in use, I don't know what are the flags to put here */
	if ( !Data->VolumeNode)
		DBG_Error( KPrintF("%s, %s(), %l04d>E: VolumeNode:%l08x\n", __FILE__, __FUNC__, __LINE__, Data->VolumeNode););
	#endif /* DEBUG */

	/* Force SubClass to overwrite this method */
	DosPacket->dp_Res1 = DOSFALSE;
	DosPacket->dp_Res2 = ERROR_ACTION_NOT_KNOWN;

	return TRUE;
}

ULONG DoFHAM_DoPacket( Class *Cl, Object *O, struct fhpDoPacket *fhpDoPacket, struct FileHandlerData * const Data)
{
	ULONG RC = NULL;	/* generic return value, meaning depend on the method */

	DBG_Trace();
	switch( fhpDoPacket->fhpdp_AsyncWork.fhpaw_State)
		{
			case FHPState_Initial:
			case FHPState_ReturnFromHostFS:
				switch( fhpDoPacket->fhpdp_DosPacket->dp_Type)
					{
						case ACTION_STARTUP:
							RC = DoFHAM_Packet_STARTUP( Cl, O, fhpDoPacket, Data);
							break;
						case ACTION_DISK_INFO:
							RC = DoFHAM_Packet_DISK_INFO( Cl, O, fhpDoPacket, Data);
							break;
						default:
							RC = DoFHAM_Packet_UNKNOWN( Cl, O, fhpDoPacket, Data);
							break;
					}
				break;
			default:	
				;
		}
	return RC;
}
