/*
 *	Copyright  1994 by S.R.
 *
 *	Created: 23 Jan 1994	16:12:50
 *	Modified:	15 May 1994	17:52:01
 *
 * Make>> smake
 */

//#undef DEBUG
#include "/Debug.h"

#include "/File-HandlerClass.h"
#include "File-Handler.h"
#include "Handler.h"

#include "proto/OM_New.h"
#include "proto/OM_Dispose.h"
#include "proto/OM_Get.h"
#include "proto/OM_Set.h"
#include "proto/OM_Update.h"
#include "proto/FHM_DoPacket.h"
#include "proto/MTools.h"
#include "proto/HostFSAccess.h"
#include "proto/ASyncReadWrite.h"

extern struct IntuitionBase *IntuitionBase;

static ULONG __saveds __asm Dispatch( register __a0 Class *Cl, register __a2 Object *O, register __a1 Msg M);

Class *InitCl( void)
{
	Class *Cl;

	DBG_Trace();
	if ( Cl = MakeClass( "File-Handler",
					"rootclass",
					NULL,
					sizeof (struct FileHandlerData),
					0))
		{
			Cl->cl_Dispatcher.h_Entry = ( ULONG (*)())Dispatch;
			Cl->cl_Dispatcher.h_SubEntry = NULL;
			//Cl->cl_Dispatcher.h_Data = &FileHandlerData;	/* not neccsary in a Class */
			AddClass( Cl);
			return Cl;
		}
}

BOOL FreeCl( Class *Cl)
{
	DBG_Trace();
	//WARN: controler si echoue
	RemoveClass( Cl);	/* NULL ptr on private class is legal */
	return FreeClass( Cl);
}

static ULONG __saveds __asm Dispatch( register __a0 Class *Cl, register __a2 Object *O, register __a1 Msg M)
{
	ULONG RC = NULL;	/* generic return value, meaning depend on the method */
	struct FileHandlerData * const Data = INST_DATA( Cl, O);

	DBG_Info1( KPrintF("%s, %s(), %l04d>MethodID:$%l08x\n", __FILE__, __FUNC__, __LINE__, M->MethodID););
	switch ( M->MethodID)
		{
			case OM_NEW:
				RC = OM_New( Cl, O, (struct opSet * const)M, Data);
				break;
			case OM_DISPOSE:
				RC = OM_Dispose( Cl, O, M, Data);
				break;
			case OM_GET:
				RC = OM_Get( Cl, O, ( struct opGet * const)M, Data);
				break;
			case OM_SET:
				RC = OM_Set( Cl, O, ( struct opSet * const)M, Data);
				break;
			case OM_UPDATE:
				RC = OM_Update( Cl, O, (struct opUpdate * const)M, Data);
				break;

			case FHAM_DoPacket:
				RC = DoFHAM_DoPacket( Cl, O, (struct fhpDoPacket *)M, Data);
				break;

			case FHM_MountDOSDev:
				RC = DoFHM_MountDOSDev( Cl, O, &(( (struct TagItem *)M)[ 1]), Data);
				break;
			case FHM_SendAWaitingServicePacket:
				RC = (ULONG)DoFHM_SendAWaitingServicePacket( Cl, O, &(( (struct TagItem *)M)[ 1]), Data);
				break;
			case FHM_AddAWaitingServicePacket:
				RC = (ULONG)DoFHM_AddAWaitingServicePacket( Cl, O, &(( (struct TagItem *)M)[ 1]), Data);
				break;
			case FHM_AddAndSendAWaitingServicePacket:
				RC = (ULONG)DoFHM_AddAndSendAWaitingServicePacket( Cl, O, &(( (struct TagItem *)M)[ 1]), Data);
				break;
			case FHM_ReplyPacket:
				RC = (ULONG)DoFHM_ReplyPacket( Cl, O, &(( (struct TagItem *)M)[ 1]), Data);
				break;
			case FHM_MakeVolumeNode:
				RC = (ULONG)DoFHM_MakeVolumeNode( Cl, O, &(( (struct TagItem *)M)[ 1]), Data);
				break;
			case FHM_Startup:
				RC = (ULONG)DoFHM_Startup( Cl, O, &(( (struct TagItem *)M)[ 1]), Data);
				break;
			case FHM_HandleSignal:
				RC = (ULONG)DoFHM_HandleSignal( Cl, O, &(( (struct TagItem *)M)[ 1]), Data);
				break;
			case FHM_NewFileLock:
				RC = (ULONG)DoFHM_NewFileLock( Cl, O, &(( (struct TagItem *)M)[ 1]), Data);
				break;

			case FHM_Handler:
				RC = (ULONG)DoFHM_Handler( Cl, O, &(( (struct TagItem *)M)[ 1]), Data);
				break;

			case FHAM_AsyncRead:
				RC = (ULONG)DoFHAM_AsyncRead( Cl, O, (struct fhpAsyncRW *)M, Data);
				break;
			case FHAM_AsyncWrite:
				RC = (ULONG)DoFHAM_AsyncWrite( Cl, O, (struct fhpAsyncRW *)M, Data);
				break;

			default:
				RC = DoSuperMethodA( Cl, O, M);
				break;
		}
	DBG_Info1( KPrintF("%s, %s(), %l04d>Return:$%l04x\n", __FILE__, __FUNC__, __LINE__, RC););
	return (ULONG)RC;
}
