/*
 *	Copyright  1991 by S.R.
 *
 *	Created: 06 Mar 1994
 *	Modified:	15 May 1994	22:35:44
 *
 * Make>> smake
 */

#include "/Debug.h"

#include "/File-HandlerClass.h"
#include "File-Handler.h"

#include "proto/HostFSAccess.h"

struct WaitingServicePacket
{
	struct MinNode Node;						/* Node to link it in a list */
	struct DosPacket *ServicePacket;		/* the Packet to send to HostFS which help to Process the initial DosPacket */
	struct fhpAsyncWork *fhpAsyncWork;	/* Hold the Packet/HandlerAction this struct help to process */
};


/* Send Packet at the tail of the list, return the sended Packet. Check if if there are alredy a packet sended, so it is safe to call it, even if there are a servicepacket we wait it's come back */
struct DosPacket *DoFHM_SendAWaitingServicePacket(	Class *Cl, Object *O, struct TagItem TagP[], struct FileHandlerData * const Data)
{
	//DBG_Trace();
	if ( !Data->ServicePacketInProgress)
		{
			/* only send a ServicePacket if there are no one in progress */
			struct WaitingServicePacket *WaitingServicePacket;

			if ( WaitingServicePacket = (struct WaitingServicePacket *)RemTail( (struct List *)&Data->WaitingServicePacketList))
				{
					Data->ServicePacketInProgress = WaitingServicePacket->ServicePacket;
					Data->fhpAsyncWorkInProgress = WaitingServicePacket->fhpAsyncWork;

					SendPkt( Data->ServicePacketInProgress, Data->HostFileSystemPort, Data->HostFileSystemReplyPort);
					FreeVec( WaitingServicePacket);
				}
			else
				{
					/* No more ServicePacket to sent */
					Data->ServicePacketInProgress = NULL;
					Data->fhpAsyncWorkInProgress = NULL;
				}
		}
	else
		;/* Nothing to do but waiting reply of the ServicePacket in progress */

	return Data->ServicePacketInProgress;
}


/* Put a Packet in the waiting list, return TRUE if success */
BOOL DoFHM_AddAWaitingServicePacket( Class *Cl, Object *O, struct TagItem TagP[], struct FileHandlerData * const Data)
{
	struct DosPacket *ServicePacket;
	struct fhpAsyncWork *fhpAsyncWork;
	struct WaitingServicePacket *WaitingServicePacket;

	//DBG_Trace();
	ServicePacket = (struct DosPacket *)GetTagData( FHP_Packet, NULL, TagP);
	fhpAsyncWork = (struct fhpAsyncWork *)GetTagData( FHP_AsyncWork, NULL, TagP);
	if ( ServicePacket && fhpAsyncWork && ( WaitingServicePacket = AllocVec( sizeof( struct WaitingServicePacket), MEMF_ANY)))
		{
			WaitingServicePacket->ServicePacket = ServicePacket;
			WaitingServicePacket->fhpAsyncWork = fhpAsyncWork;

			AddHead( (struct List *)&Data->WaitingServicePacketList, (struct Node *)WaitingServicePacket);
			return TRUE;
		}
	else
		{
			DBG_Error( KPrintF("%s, %s(), %l04d>E:ServicePacket:%l08x, fhpAsyncWork:%l08x\n", __FILE__, __FUNC__, __LINE__, ServicePacket, fhpAsyncWork););
		}

	return FALSE;
}

struct DosPacket *DoFHM_AddAndSendAWaitingServicePacket( Class *Cl, Object *O, struct TagItem TagP[], struct FileHandlerData * const Data)
{
	/* Since the called function are in same file, I directly call it whithout passing by Method() */
	if ( DoFHM_AddAWaitingServicePacket( Cl, O, TagP, Data))
		{
			return DoFHM_SendAWaitingServicePacket( Cl, O, TagP, Data);
		}
	else
		return NULL;
}
