/*
 * Make>> SMake
 *
 */

#define __USE_SYSBASE

#include "File-Handler.library_rev.h"
#include "File-Handler.h"
#include "proto/File-Handler.h"

#include "proto/Tools.h"
#include "proto/AsyncWork.h"

/* library initialization table, used for AUTOINIT libraries                */
struct InitTable
{
	ULONG it_DataSize;	/* library data space size         */
	PVF *it_FuncTable;	/* table of entry points           */
	APTR it_DataInit;	/* table of data initializers      */
	void (*it_InitFunc)( void);	/* initialization function to run  */
};

BPTR __saveds __asm LibExpunge(register __a6 struct FileHandlerBase * LibBase);
struct FileHandlerBase * __saveds __asm LibInit(register __a0 BPTR seglist,  register __d0 struct FileHandlerBase *LibBase);
struct FileHandlerBase * __saveds __asm LibOpen(register __a6 struct FileHandlerBase * LibBase);
BPTR __saveds __asm LibClose(register __a6 struct FileHandlerBase * LibBase);

far extern struct Resident LibRomTag;	/* Came from ASM */

struct ExecBase *SysBase;
struct DosLibrary *DOSBase;
struct IntuitionBase *IntuitionBase;
struct Library *UtilityBase;

const char VersTag[] = VERSTAG "  S.R ";
const char LibName[] = "file-handler.library";

/* NEVER forget the far or SASC put the offset from data segment, not the Ptr */
far PVF Lib_FuncTab[] =
{
	( PVF)LibOpen,		/* standard open	*/
	( PVF)LibClose,		/* standard close	*/
	( PVF)LibExpunge,	/* standard expunge	*/
	0,	/* futur Commodore expansion */

/* real lib functions */
	( PVF) MountFile,
	( PVF) ContinueAsyncMethod,
	( PVF) StartAsyncMethod,
	( PVF) -1L
};	

far struct InitTable LibInitTab =
{
	sizeof(struct FileHandlerBase),
	Lib_FuncTab,
	NULL,			/* will initialize my own data */
	( void (*)())LibInit,
};

struct FileHandlerBase * __saveds __asm LibInit(register __a0 BPTR seglist,  register __d0 struct FileHandlerBase *LibBase)
{
	SysBase = *( (struct ExecBase **)4L);

	LibBase->SegList = seglist;

	/* init. library structure (since I don't do automatic data init.) */
	LibBase->Lib.lib_Node.ln_Type = NT_LIBRARY;
	LibBase->Lib.lib_Node.ln_Name = (char *)LibName;
	LibBase->Lib.lib_Flags = LIBF_SUMUSED | LIBF_CHANGED;
	LibBase->Lib.lib_Version = VERSION;
	LibBase->Lib.lib_Revision = REVISION;
	LibBase->Lib.lib_IdString = (APTR) VersTag;

	return( LibBase);
}

struct FileHandlerBase * __saveds __asm LibOpen(register __a6 struct FileHandlerBase * LibBase)
{
	if ( LibBase->Lib.lib_OpenCnt == 0)
		{
			DOSBase = (struct DosLibrary *)OpenLibrary( (UBYTE *)"dos.library", 37L);
			IntuitionBase = (struct IntuitionBase *)OpenLibrary( (UBYTE *)"intuition.library", 37L);
			UtilityBase = OpenLibrary( (UBYTE *)"utility.library", 37L);
			if ( !( LibBase->Class = InitCl()))
				return NULL;
		}

	/* mark us as having another customer */
	LibBase->Lib.lib_OpenCnt++;

	/* clear delayed expunges (standard procedure)                */
	LibBase->Lib.lib_Flags &= ~LIBF_DELEXP;

	return( LibBase);
}

BPTR __saveds __asm LibClose(register __a6 struct FileHandlerBase * LibBase)
{
	BPTR retval = NULL;

	if ((--LibBase->Lib.lib_OpenCnt == 0))
		{
			FreeCl( LibBase->Class);
			LibBase->Class = NULL;	/* security */
			CloseLibrary( (struct Library *)UtilityBase);
			CloseLibrary( (struct Library *)IntuitionBase);
			CloseLibrary( (struct Library *)DOSBase);
			if ( LibBase->Lib.lib_Flags & LIBF_DELEXP)
				{
					/* no more people have me open, and I have a delayed expunge pending */
					retval = LibExpunge(LibBase);	/* return segment list        */
				}
		}

	return (retval);
}

BPTR __saveds __asm LibExpunge(register __a6 struct FileHandlerBase * LibBase)
{
	BPTR SegList = NULL;

	LibBase->Lib.lib_Flags |= LIBF_DELEXP;
	if (LibBase->Lib.lib_OpenCnt == 0)
		{
			Remove((struct Node *) LibBase);

			/* really expunge: remove LibBase and freemem        */
			SegList = LibBase->SegList;

			{
				LONG LibSize;
				LibSize = LibBase->Lib.lib_NegSize + LibBase->Lib.lib_PosSize;
				FreeMem((char *) LibBase - LibBase->Lib.lib_NegSize, (LONG) LibSize);
			}
		}
	else
		LibBase->Lib.lib_Flags |= LIBF_DELEXP;

	/* return NULL or real seglist                                */
	return( SegList);
}
