/*
 *	Copyright  1991 by S.R.
 *
 *	Created: 26 Aug 1993	17:27:34
 *	Modified:	16 May 1994	17:05:06
 *
 * Make>> smake
 */

#include "/Debug.h"

#include "proto/Misc.h"

void NewMinList(struct MinList *MinList)
{
	MinList->mlh_Head = (struct MinNode *)&MinList->mlh_Tail;
	MinList->mlh_Tail = NULL;
	MinList->mlh_TailPred = (struct MinNode *)MinList;
}

/* reply the Packet: special way, this must be done each time the Packet is use */
void ReplyPacket( struct DosPacket *Packet, struct MsgPort *DosPort)
{
	struct MsgPort *ReplyPort;
	struct Message *Msg;

	#ifdef DEBUG
		if( !Packet || !DosPort)
			{
				KPrintF("%s, %s(), %l04d>E:Packet:%l08x, DosPort:%l08x\n", __FILE__, __FUNC__, __LINE__, Packet, DosPort);
				return;
			}
	#endif
	
	ReplyPort = Packet->dp_Port;
	Msg = Packet->dp_Link; 
	Packet->dp_Port = DosPort;
	Msg->mn_Node.ln_Name = ( char *)Packet;
	Msg->mn_Node.ln_Succ = NULL;
	Msg->mn_Node.ln_Pred = NULL;
	DBG_Info1( KPrintF("%s, %s(), %l04d>Packet Type:%ld (replying).\n", __FILE__, __FUNC__, __LINE__, (LONG)Packet->dp_Type););

	PutMsg( ReplyPort, Msg);
}


/* allocated by AllocMem() (because of the little size) and with MEMF_PUBLIC (to avoid multi-process acces) */
char * CStrToBStr( char CStr[])
{
	ULONG l;
	char *BStr;

	l = strlen( CStr);
	#ifdef DEBUG
		if ( l > 255)
			{
				DBG_Error( KPrintF("%s, %s(), %l04d>E:BSTR too long:$%l08x\n", __FILE__, __FUNC__, __LINE__, l););
				return NULL;
			}
	#endif
	if ( BStr = AllocMem( l + 1 + 1, MEMF_PUBLIC))
		{
			strcpy( &BStr[ 1], CStr);
			BStr[ 0] = l;
			return BStr;
		}

	return NULL;
}

/* this way, they can happen missuse of FreeMem()/FreeVec() */
void FreeBStr( char BStr[])
{
	FreeMem( BStr, BStr[ 0]);
}
