/*
 *	Copyright  1991 by S.R.
 *
 *	Created: 26 Aug 1993	17:27:34
 *	Modified:	04 Jun 1994	14:26:04
 *
 * Make>> smake
 */

#include "/Debug.h"

#include "proto/Misc.h"

void NewMinList(struct MinList *MinList)
{
	MinList->mlh_Head = (struct MinNode *)&MinList->mlh_Tail;
	MinList->mlh_Tail = NULL;
	MinList->mlh_TailPred = (struct MinNode *)MinList;
}

struct MinNode *GetHead( struct MinList *L)
{
	return L->mlh_Head->mln_Succ ? L->mlh_Head : NULL;
}

struct MinNode *GetSucc( struct MinNode *N)
{
	return N->mln_Succ->mln_Succ ? N->mln_Succ : NULL;
}

BOOL IsDir( STRPTR Name)
{
	UWORD l;

	l = strlen( Name) - 1;
	if ( ( Name[ l] == '/') || ( Name[ l] == ':'))
		{
			return TRUE;
		}
	else
		{
			return FALSE;
		}
}


void DivideName( STRPTR FullPathName, STRPTR PathName, STRPTR BaseName)
{
	WORD i;
	WORD l;

	l = strlen( FullPathName) - 1;
	strcpy( PathName, FullPathName);
	BaseName[ 0] = '\0';

	if ( ( PathName[ l] == '/'))
		l--;	/* the ending '/' is NOT a dir separator but mark that the object itself are a dir, so it must remaind in the BaseName */

	for( i = l; i >= 0; i--)
		{
			if ( ( PathName[ i] == '/') || ( PathName[ i] == ':'))
				{
					strcpy( BaseName, &PathName[ i + 1]);
					PathName[ i + 1] = '\0';
					return;
				}
		}

	/* no path part, only the name of the object */
	strcpy( BaseName, FullPathName);
	PathName[ 0] = '\0';
}

ULONG NumberOfBlock( ULONG n, ULONG SizeBlock)
{
	ULONG bn;

	bn = n / SizeBlock;
	if ( n % SizeBlock)
		bn++;

	return bn;
}

void CStrToBStr( STRPTR CStr, STRPTR BStr)
{
	UBYTE l;

	l = strlen( CStr);

	strcpy( &BStr[ 1], CStr);
	BStr[ 0] = l;
}

ULONG Oct( STRPTR OctalString)
{
	char Buffer[ 255];
	long n;
	char *b = Buffer;

	strncpy( Buffer, OctalString, 255);
	while( isspace( *b))	
		b++;
	stco_l( b, &n);

	return (ULONG)n;
}

/*
	Vol:Dir1/Dir2/Dir3/File
	Vol:Dir1/Dir2/Dir3/
	Vol:Dir1/Dir2/File

	Dir1/Dir2/Dir3/File
	Dir1/Dir2/Dir3/
	Dir1/Dir2/File

	Vol:File
*/
STRPTR PartName( STRPTR FullPathName, STRPTR Part, UBYTE PartNum, BOOL IncludeVolumeName)
{
	STRPTR n;
	STRPTR s;
	UBYTE i;

	if( !IncludeVolumeName)
		{
			s = strchr( FullPathName, ':');
			if ( s)
				s++;
			else
				s = FullPathName;
		}
	else
		s = FullPathName;

	n = s;
	for ( i = 0; i < PartNum; i++)
		{
			n = strchr( n, '/');
			if( !n)
				{
					Part[ 0] = '\0';
					return NULL;
				}
			else
				n++;	/* skip the '/' */
		}

	for( i = 0; n[ i] && ( n[ i] != '/'); i++)
		;
	strncpy( Part, n, i);
	Part[ i] = '\0';

	return Part;
}
