/*
 *	Copyright  1994 by S.R.
 *
 *	Created: 23 Jan 1994	16:12:50
 *	Modified:	18 May 1994	22:25:09
 *
 * Make>> smake
 */

//#undef DEBUG
#include "/Debug.h"

#include "/File-HandlerClass.h"
#include "/Tar-FileHandlerClass.h"
#include "Tar-FileHandler.h"

#include "proto/OM_New.h"
#include "proto/OM_Dispose.h"
#include "proto/OM_Get.h"
#include "proto/OM_Set.h"
#include "proto/OM_Update.h"
#include "proto/FHM_DoPacket.h"
#include "proto/MTools.h"
#include "proto/TarObject.h"

/* dbg */
#include "/File-Handler_pragmas.h"
#include "/File-Handler_protos.h"

extern struct IntuitionBase *IntuitionBase;

struct Library *FileHandlerBase;

static ULONG __saveds __asm far Dispatch( register __a0 Class *Cl, register __a2 Object *O, register __a1 Msg M);

Class *InitCl( void)
{
	Class *Cl;

	DBG_Trace();
	FileHandlerBase = OpenLibrary( "file-handler.library", 0L);	/* since this library hold the superclass, this open can't faild */
	#ifdef DEBUG
		if ( !FileHandlerBase)
			{
				DBG_Error( KPrintF("%s, %s(), %l04d>E:FileHandlerBase:%lx\n", __FILE__, __FUNC__, __LINE__, (LONG)FileHandlerBase));
				return NULL;
			}
	#endif
	if ( Cl = MakeClass( "Tar-FileHandler",
					"File-Handler",
					NULL,
					sizeof (struct TarFileHandlerData),
					0))
		{
			Cl->cl_Dispatcher.h_Entry = ( ULONG (*)())Dispatch;
			Cl->cl_Dispatcher.h_SubEntry = NULL;
			//Cl->cl_Dispatcher.h_Data = &TarFileHandlerData;	/* not neccsary in a Class */
			AddClass( Cl);
DBG_Trace();
			return Cl;
		}
}

BOOL FreeCl( Class *Cl)
{
	DBG_Trace();
	CloseLibrary( FileHandlerBase);
	RemoveClass( Cl);	/* NULL ptr on private class is legal */
	return FreeClass( Cl);
}

static ULONG __saveds __asm far Dispatch( register __a0 Class *Cl, register __a2 Object *O, register __a1 Msg M)
{
	ULONG RC = NULL;	/* generic return value, meaning depend on the method */
	struct TarFileHandlerData * const Data = INST_DATA( Cl, O);

	DBG_Info1( KPrintF("%s, %s(), %l04d>MethodID:$%l08x\n", __FILE__, __FUNC__, __LINE__, M->MethodID););
	//DBG_Info1( Delay( 100L););
	switch ( M->MethodID)
		{
			case OM_NEW:
				RC = OM_New( Cl, O, (struct opSet * const)M, Data);
				break;
			case OM_DISPOSE:
				RC = OM_Dispose( Cl, O, M, Data);
				break;
			case OM_GET:
				RC = OM_Get( Cl, O, ( struct opGet * const)M, Data);
				break;
			case OM_SET:
				RC = OM_Set( Cl, O, ( struct opSet * const)M, Data);
				break;
			case OM_UPDATE:
				RC = OM_Update( Cl, O, (struct opUpdate * const)M, Data);
				break;

			case FHM_Startup:
				RC = (ULONG)DoFHM_Startup( Cl, O, &(( (struct TagItem *)M)[ 1]), Data);
				break;

			case FHAM_DoPacket:	/* This method() will be overwrittend by all new FileHandler Class so they do real work with Packet */
				RC = DoFHAM_DoPacket( Cl, O, (struct fhpDoPacket *)M, Data);
				break;

			case TFHAM_ReadAllDir:
				RC = DoTFHAM_ReadAllDir( Cl, O, (struct fhpAsyncWork *)M, Data);

			default:
				RC = DoSuperMethodA( Cl, O, M);
				break;
		}
	DBG_Info1( KPrintF("%s, %s(), %l04d>Return:$%l04x\n", __FILE__, __FUNC__, __LINE__, RC););
	return (ULONG)RC;
}
