/*

        LHA-Handler

        (c) 1994 : Pierre CARETTE, Sylvain ROUGIER,
                   Bertrand LE CUN, Jean-Baptiste YUNES

*/
/*
#define DEBUG
*/

#include <exec/types.h>
#include <exec/memory.h>
#include <exec/nodes.h>
#include <exec/lists.h>
#include <proto/exec.h>
#include <proto/dos.h>

#include <stdio.h>
#include <time.h>

#include "lharc.h"

#define ERROR			int
#define NO_ERROR		0
#define BAD_HEADER_SIZE		1
#define SHORT_HEADER		2
#define BAD_HEADER_CHECKSUM	3
#define UNKNOWN_HEADER_TYPE	4
#define SHORT_FILE		5
#define END_OF_ARCHIVE		6
#define BAD_ALLOC		7

#define GENERIC_TO_UNIX		1
#define MACOS_TO_UNIX		2
#define MSDOS_TO_UNIX		3

/* Remember the FileInfoBlock
struct FileInfoBlock {
	// Used with ACTION_EXAMINE_OBJECT ACTION_EXAMINE_NEXT
	LONG			fib_DiskKey;
	// -5 (pipe) -4 (hard link to file) -3 (file) 1 (root dir) 2 (dir)
	// 3 (soft link) 4 (hard link to dir)
	LONG			fib_DirEntryType;
	// FileName, currently using 30 chars max.
	char			fib_FileName[108];
	// ...
	LONG			fib_Protection;
	// Please make this entry equals to DirEntryType...
	LONG			fib_EntryType;
	// File size in bytes
	LONG			fib_Size;
	// File size in blocks
	LONG			fib_NumBlocks;
	// Post-Office
	struct DateStamp	fib_Date;
	// Put what you like here
	char			fib_Comment[80];
	// Don't touch this, man...
	char			fib_Reserved[36];
};
*/

struct LHAEntry {
	struct Node		brothers;
	LONG			DirEntryType;
	LONG			Protection;
	LONG			Size;
	LONG			DateStamp;
	struct List		*sons;
};
typedef struct LHAEntry	LHAEntry;

ERROR	Add_Header_2_LHA_Tree(LzHeader *,struct List *);
void	Print_LHA_Tree(struct List *,char *);
void	Free_LHA_Tree(struct List *);

#define MAX_EXTRACTION	80
