/*
 *  Archive.h - Copyright ) 1994 by S.R. & P.C.
 *
 *  Created:    17 Mar 1994  20:05:22
 *  Modified:   07 Dec 1994  12:53:00
 *
 *  Make>> smake
 */

#include <archives/ArchiveClass.h>


#define STACKSIZE (50*1024)


struct ArchiveBase {
	struct Library Lib;
	ULONG  SegList;							/* seg list of lib itself */
	Class *Class;							/* the Class */
	struct SignalSemaphore MountSemaphore;	/* Prevents concurent mount */
	struct MinList ArchiveTypes;			/* List of known archive file types */
};


enum ArchiveScanState {
	SS_NotScanned,
	SS_ScanInProgress,
	SS_ScanDone
};


struct PrivateArchiveEntry {
	struct ArchiveEntry Entry;				/* the public struct Entry */
	LONG  ae_Access;						/* none, exclusive, shared */
	ULONG ae_AccessCnt;						/* Shared access count */
};


struct PrivateArchiveHandle {
	struct ArchiveHandle ah_Handle;		/* the public struct Handle */
	LONG ah_Access;						/* Lock() Access mode */
};


struct ArchiveData {
	struct Library *ObjLibBase;
	struct MsgPort *ASyncReplyPort;	/* Reply Port for ASync messages */
	struct Process *HandlerProcess;	/* Handler's process */
	struct MsgPort *SlavePort;		/* PutMsg() to slave process here */
	struct DosList *DeviceNode;		/* Device for the archive volume */
	struct DosList *VolumeNode;		/* Volume node for the archive */
	UBYTE  DeviceName[32];			/* DOS Device name WITH ending ':' */
	UBYTE  SlaveProcName[40];		/* Slave process name */
	enum   ArchiveScanState ScanState;
	struct PrivateArchiveEntry *RootEntry;
	struct SignalSemaphore MemPoolSemaphore;
	APTR   MemoryPool;
	APTR   OriginalHandlerStack;	/* Stack to restore when living handler (Dummy ASyncRequest) */
	ULONG  ASyncRequestCnt;			/* Number of pending ASync requests */
	ULONG  NumLocks;				/* Number of locks */
	ULONG  Flags;
};


/* ArchiveData Flags */
#define ADF_QuitHandler		0x0001	/* Quit as soon as possible */
#define ADF_UnMount			0x0002	/* UnMount phase. Do not Wait() in WaitLoop. (may be called after a fail to AttempLockDosList()) */


