
#ifndef ARCHIVEMETHODS_H
#define ARCHIVEMETHODS_H

ULONG ahm_DoPacket(Class *Cl, Object *O, struct ahpDoPacket *M);
static ULONG __inline DoAHM_DoPacket(Object *O, struct DosPacket *Pkt, Tag Tag1, ...)
{
	return DoMethod(O, AHM_DoPacket, Pkt, &Tag1);
}

BPTR ahm_Startup(Class *Cl, Object *O, struct opTagList *M);
static BPTR __inline DoAHM_Startup(Object *O, Tag Tag1, ...)
{
	return (BPTR)DoMethod(O, AHM_Startup, &Tag1);
}

void ahm_Finish(Class *Cl, Object *O, struct opTagList *M);
static void __inline DoAHM_Finish(Object *O, Tag Tag1, ...)
{
	DoMethod(O, AHM_Finish, &Tag1);
}

BPTR am_Mount(Class *Cl, Object *O, struct opTagList *M);
static BPTR __inline DoAM_Mount(Object *O, Tag Tag1, ...)
{
	return (BPTR)DoMethod(O, AM_Mount, &Tag1);
}

ULONG aahm_ScanArchive(Class *Cl, Object *O, struct opTagList *M);
static ULONG __inline DoAAHM_ScanArchive(Object *O, Tag Tag1, ...)
{
	return DoASyncMethod(O, AAHM_ScanArchive, &Tag1);
}

ULONG aahm_WaitEndScan(Class *Cl, Object *O, struct opTagList *M);
static ULONG __inline DoAAHM_WaitEndScan(Object *O, Tag Tag1, ...)
{
	return DoASyncMethod(O, AAHM_WaitEndScan, &Tag1);
}


ULONG aahm_ReadFirstHeader(Class *Cl, Object *O, struct aahpReadHeader *M);
static ULONG __inline DoAAHM_ReadFirstHeader(Object *O, struct aahpReadHeader *M, Tag Tag1, ...)
{
	M->MethodID = AAHM_ReadFirstHeader;
	M->TagList = (struct TagItem *)&Tag1;
	return DoASyncMethodA(O, (Msg *)M);
}

ULONG aahm_ReadNextHeader(Class *Cl, Object *O, struct aahpReadHeader *M);
static ULONG __inline DoAAHM_ReadNextHeader(Object *O, struct aahpReadHeader *M, Tag Tag1, ...)
{
	M->MethodID = AAHM_ReadNextHeader;
	M->TagList = (struct TagItem *)&Tag1;
	return DoASyncMethodA(O, (Msg *)M);
}

ULONG aahm_ReadHeaderEnd(Class *Cl, Object *O, struct aahpReadHeader *M);
static ULONG __inline DoAAHM_ReadHeaderEnd(Object *O, struct aahpReadHeader *M, Tag Tag1, ...)
{
	M->MethodID = AAHM_ReadHeaderEnd;
	M->TagList = (struct TagItem *)&Tag1;
	return DoASyncMethodA(O, (Msg *)M);
}


ULONG aahm_Open(Class *Cl, Object *O, struct aahpOpen *M);
static ULONG __inline DoAAHM_Open(Object *O, struct ArchiveHandle *ArchiveHandle, LONG *Error, Tag Tag1, ...)
{
	return DoASyncMethod(O, AAHM_Open, ArchiveHandle, Error, &Tag1);
}

ULONG aahm_Read(Class *Cl, Object *O, struct aahpRead *M);
static ULONG __inline DoAAHM_Read(Object *O, struct ArchiveHandle *ArchiveHandle, APTR Buffer,
											 LONG BytesToRead, LONG *BytesRead, LONG *Error, Tag Tag1, ...)
{
	return DoASyncMethod(O, AAHM_Read, ArchiveHandle, Buffer, BytesToRead, BytesRead, Error, &Tag1);
}

ULONG aahm_Close(Class *Cl, Object *O, struct aahpClose *M);
static ULONG __inline DoAAHM_Close(Object *O, struct ArchiveHandle *ArchiveHandle, Tag Tag1, ...)
{
	return DoASyncMethod(O, AAHM_Close, ArchiveHandle, &Tag1);
}


#endif

