/*
 *  Header.c - Copyright ) 1994 by S.R. & P.C.
 *
 *  Created:    30 Nov 1994  23:42:40
 *  Modified:   03 Dec 1994  22:47:43
 *
 *  Make>> smake
 */

#include <clib.h>
#include "Debug.h"

#include <proto/Archive.h>
#include <archives/ArchiveClass.h>
#include <archives/LhaClass.h>
#include <archives/ArchiveMethods.h>
#include <archives/LhaMethods.h>

#include "Lha.h"
#include "proto/Header.h"


#define HEADERSIZE 512		/* not the size of the struct, but this still the size of the header ! */
#define NAMESIZE 100
#define TUNAMELEN 32
#define TGNAMELEN 32

char TheFileName[100];

#include "LHAUtils.h"
#define LhaHeader	LzHeader

struct ReadHeaderContext {
	UBYTE Buffer[HEADERSIZE];
};

static ULONG ReadHeader(Class *Cl, Object *O, struct aahpReadHeader *M,
	LhaHeader *Header)
{
	struct LhaData		*const Data = INST_DATA(Cl, O);
	struct ArchiveEntry	*ArchiveEntry;
	struct LhaEntry		*LhaEntry;
	int			l;

/*
	Header = (struct LhaHeader *)((struct ReadHeaderContext *)M->UserData)->Buffer;
*/
	if (ArchiveEntry = AllocArchiveObjectA(O, AO_Entry, NULL)) {
		M->Entry = ArchiveEntry;
		l = strlen(Header->name);
		if (Header->name[l-1]=='/' || Header->name[l-1]==':') {
			Header->name[l-1] = '\0';
			ArchiveEntry->ae_EntryType = ST_USERDIR;
		}
		else
			ArchiveEntry->ae_EntryType = ST_FILE;
		strncpy(ArchiveEntry->ae_Name,FilePart(Header->name), 31);
		strcpy(M->DirPath,Header->name);
		*PathPart(M->DirPath) = '\0';		// remove entry name. just keep parent dir path.
		ArchiveEntry->ae_Size = Header->original_size;
		ArchiveEntry->ae_PackedSize = Header->packed_size;
		ArchiveEntry->ae_NumBlocks = (ArchiveEntry->ae_Size + 511) / 512;	/* round up */

		LhaEntry = INST_EntryData(Cl, ArchiveEntry);
/*
		LhaEntry->te_Offset = Vieille valeur de Data->cumul_size
*/
	}
	else
		M->Error = ERROR_NO_FREE_STORE;
	return TRUE;
}


ULONG aahm_ReadFirstHeader(Class *Cl, Object *O, struct aahpReadHeader *M)
{
	struct LhaData *const Data = INST_DATA(Cl, O);
	int		size;
	LzHeader	lzheader;

	Data->cumul_size = 0;	/* Start counting header sizes */
	/* Allocate a buffer to work on */
	Data->LhaBuffer = AllocVec(LZHEADER_STRAGE,MEMF_PUBLIC|MEMF_CLEAR);
	if (Data->LhaBuffer==NULL) {
		M->Error = ERROR_NO_FREE_STORE;
		return TRUE;
	}
	if (M->UserData = AllocVec(sizeof(struct ReadHeaderContext),
		MEMF_PUBLIC|MEMF_CLEAR)) {
		if (Data->LhaFH = DoTAHM_OpenLhaFile(O,Data->LhaFileLock,
			TAG_END)) {
			read_header(Data->LhaFH,&lzheader,&size,Data->LhaBuffer);
			strcpy(TheFileName,lzheader.name);
			Data->cumul_size += lzheader.packed_size+size;
			return ReadHeader(Cl, O, M, &lzheader);
		}
		else
			M->Error = IoErr();
	}
	else
		M->Error = ERROR_NO_FREE_STORE;
	return TRUE;
}


ULONG aahm_ReadNextHeader(Class *Cl, Object *O, struct aahpReadHeader *M)
{
	struct LhaData *const Data = INST_DATA(Cl, O);
	LzHeader	lzheader;
	int		size;
	ERROR		e;

	Seek(Data->LhaFH,Data->cumul_size,OFFSET_BEGINNING);
	e=read_header(Data->LhaFH,&lzheader,&size,Data->LhaBuffer);
	if (e==END_OF_ARCHIVE)	M->Error = ERROR_NO_MORE_ENTRIES;
	else {
		Data->cumul_size += lzheader.packed_size+size;
		strcpy(TheFileName,lzheader.name);
		return ReadHeader(Cl, O, M, &lzheader);
	}
	return TRUE;
}


ULONG aahm_ReadHeaderEnd(Class *Cl, Object *O, struct aahpReadHeader *M)
{
	struct LhaData *const Data = INST_DATA(Cl, O);

	if (Data->LhaBuffer) {
		FreeVec(Data->LhaBuffer);
		Data->LhaBuffer = NULL;
	}
	if (M->UserData) FreeVec(M->UserData);
	return TRUE;
}


BPTR tahm_OpenLhaFile(Class *Cl, Object *O, struct tahpOpenLhaFile *M)
{
	BPTR fl, fh = NULL;

	if (fl = DupLock(M->FileLock)) {		// Duplicate lock which will be 'absorbed' by OpenFromLock()
		if (!(fh = OpenFromLock(fl)))
			UnLock(fl);
	}
	return fh;
}


void thm_CloseLhaFile(Class *Cl, Object *O, struct thpCloseLhaFile *M)
{
	if (M->FH)
		Close(M->FH);
}

