/*
 *  Header.c - Copyright ) 1994 by S.R. & P.C.
 *
 *  Created:    30 Nov 1994  23:42:40
 *  Modified:   03 Dec 1994  22:47:43
 *
 *  Make>> smake
 */

#include <clib.h>
#include "Debug.h"

#include <proto/Archive.h>
#include <archives/ArchiveClass.h>
#include <archives/LhaClass.h>
#include <archives/ArchiveMethods.h>
#include <archives/LhaMethods.h>

#include "Lha.h"
#include "proto/Header.h"


#define HEADERSIZE LZHEADER_STRAGE		/* not the size of the struct, but this still the size of the header ! */
#define NAMESIZE 100
#define TUNAMELEN 32
#define TGNAMELEN 32

#include "LhaUtils.h"
#define LhaHeader	LzHeader

int	decode8(unsigned char *);
int	decode16(unsigned char *);
int	decode32(unsigned char *);

struct ReadHeaderContext {
	UBYTE Buffer[HEADERSIZE];
};


static ULONG ReadHeader(Class *Cl, Object *O, struct aahpReadHeader *M)
{
	struct LhaData *const Data = INST_DATA(Cl, O);
	struct ArchiveEntry *ArchiveEntry;
	struct LhaEntry *LhaEntry;
	struct LhaHeader *Header;
	int	read_size;
	char	buffer[50];

	Header = (struct LhaHeader *)((struct ReadHeaderContext *)M->UserData)->Buffer;
	read_size = Read(Data->LhaFH,&buffer,50);
	if (read_size!=50) {
		M->Error = ERROR_NO_MORE_ENTRIES;
		return TRUE;
	}
	strncpy(Header->name,buffer+22,7);
	Header->name[7] = '\0';

	Header->packed_size = 100;
	Header->original_size = 120;
	if (ArchiveEntry = AllocArchiveObjectA(O, AO_Entry, NULL)) {
		M->Entry = ArchiveEntry;
		ArchiveEntry->ae_EntryType = ST_FILE;
		strncpy(ArchiveEntry->ae_Name, FilePart(Header->name), 31);
		strcpy(M->DirPath, Header->name);
		*PathPart(M->DirPath) = '\0';		// remove entry name. just keep parent dir path.
		ArchiveEntry->ae_Size = Header->original_size;
		ArchiveEntry->ae_PackedSize = Header->packed_size;
		ArchiveEntry->ae_NumBlocks = (ArchiveEntry->ae_Size + 511) / 512;	/* round up */

		LhaEntry = INST_EntryData(Cl, ArchiveEntry);
/*
		LhaEntry->te_Offset = Seek(Data->LhaFH,
			Data->cumul_size, OFFSET_BEGINNING);
*/
	}
	else
		M->Error = ERROR_NO_FREE_STORE;
	return TRUE;
}


ULONG aahm_ReadFirstHeader(Class *Cl, Object *O, struct aahpReadHeader *M)
{
	struct LhaData *const Data = INST_DATA(Cl, O);

	if (M->UserData=AllocVec(sizeof(struct ReadHeaderContext),
						MEMF_PUBLIC|MEMF_CLEAR)) {
		if (Data->LhaFH=DoTAHM_OpenLhaFile(0,Data->LhaFileLock,TAG_END))
			return ReadHeader(Cl, O, M);
		else
			M->Error = IoErr();
	}
	else
		M->Error = ERROR_NO_FREE_STORE;
	return TRUE;
}


ULONG aahm_ReadNextHeader(Class *Cl, Object *O, struct aahpReadHeader *M)
{
	M->Error = ERROR_NO_MORE_ENTRIES;
	return TRUE;
}


ULONG aahm_ReadHeaderEnd(Class *Cl, Object *O, struct aahpReadHeader *M)
{
	return TRUE;
}


BPTR tahm_OpenLhaFile(Class *Cl, Object *O, struct tahpOpenLhaFile *M)
{
	BPTR fl, fh = NULL;

	if (fl = DupLock(M->FileLock)) {		// Duplicate lock which will be 'absorbed' by OpenFromLock()
		if (!(fh = OpenFromLock(fl)))
			UnLock(fl);
	}
	return fh;
}


void thm_CloseLhaFile(Class *Cl, Object *O, struct thpCloseLhaFile *M)
{
	if (M->FH)
		Close(M->FH);
}

