/*
 *  LibInit.c - Copyright ) 1994 by S.R. & P.C.
 *
 *  Created:    21 Jul 1994  21:49:24
 *  Modified:   27 Nov 1994  22:31:50
 *
 *  Make>> smake
 */

#include "Lha_rev.h"
#include "Lha.h"

#include "proto/Lha.h"

typedef void *(*PVF)();

/* library initialization table, used for AUTOINIT libraries */
struct InitTable {
	ULONG it_DataSize;			/* library data space size         */
	PVF *it_FuncTable;			/* table of entry points           */
	APTR it_DataInit;			/* table of data initializers      */
	void (*it_InitFunc) (void);	/* initialization function to run  */
};

BPTR __saveds __asm LibExpunge(register __a6 struct LhaBase *LibBase);
struct LhaBase *__saveds __asm LibInit(register __a0 BPTR seglist, register __d0 struct LhaBase *LibBase);
struct LhaBase *__saveds __asm LibOpen(register __a6 struct LhaBase *LibBase);
BPTR __saveds __asm LibClose(register __a6 struct LhaBase *LibBase);

far extern struct Resident LibRomTag;	/* Come from ASM */

struct ExecBase *SysBase;
struct DosLibrary *DOSBase;
struct Library *UtilityBase;
struct IntuitionBase *IntuitionBase;
struct Library *ArchiveBase;

const char LibID[] = VSTRING;
const char LibName[] = "lha.archive";

/* NEVER forget the far or SASC put the offset from data segment, not the Ptr */
far PVF Lib_FuncTab[] = {
	(PVF) LibOpen,				/* standard open    */
	(PVF) LibClose,				/* standard close   */
	(PVF) LibExpunge,			/* standard expunge */
	0,					/* futur Commodore expansion */

/* real lib functions */
	(PVF) - 1L
};

far struct InitTable LibInitTab = {
	sizeof(struct LhaBase),
	Lib_FuncTab,
	NULL,					/* will initialize my own data */
	(void (*)()) LibInit,
};

struct LhaBase *__saveds __asm LibInit(register __a0 BPTR seglist, register __d0 struct LhaBase *LibBase)
{
	SysBase = *((struct ExecBase **) 4L);

	LibBase->SegList = seglist;

	/* init. library structure (since I don't do automatic data init.) */
	LibBase->Lib.lib_Node.ln_Type = NT_LIBRARY;
	LibBase->Lib.lib_Node.ln_Name = (char *) LibName;
	LibBase->Lib.lib_Flags = LIBF_SUMUSED | LIBF_CHANGED;
	LibBase->Lib.lib_Version = VERSION;
	LibBase->Lib.lib_Revision = REVISION;
	LibBase->Lib.lib_IdString = (APTR)LibID;

	return (LibBase);
}

struct LhaBase *__saveds __asm LibOpen(register __a6 struct LhaBase *LibBase)
{
	if (LibBase->Lib.lib_OpenCnt == 0) {
		if (!(DOSBase = (struct DosLibrary *) OpenLibrary("dos.library", 37L)))
			return NULL;
		UtilityBase = DOSBase->dl_UtilityBase;
		IntuitionBase = (struct IntuitionBase *)OpenLibrary("intuition.library", 37L);
		if (!(ArchiveBase = OpenLibrary("archive.library", 1L)))
			return NULL;
		if (!(LibBase->Class = InitCl()))
			return NULL;
	}
	/* mark us as having another customer */
	LibBase->Lib.lib_OpenCnt++;
	/* clear delayed expunges (standard procedure)                */
	LibBase->Lib.lib_Flags &= ~LIBF_DELEXP;
	return (LibBase);
}


BPTR __saveds __asm LibClose(register __a6 struct LhaBase * LibBase)
{
	BPTR retval = NULL;

	if (--LibBase->Lib.lib_OpenCnt == 0) {
		FreeCl(LibBase->Class);
		LibBase->Class = NULL;	/* security */
		CloseLibrary(ArchiveBase);
		CloseLibrary(IntuitionBase);
		CloseLibrary(DOSBase);
		if (LibBase->Lib.lib_Flags & LIBF_DELEXP) {
			/* no more people have me open, and I have a delayed expunge pending */
			retval = LibExpunge(LibBase);	/* return segment list        */
		}
	}
	return (retval);
}


BPTR __saveds __asm LibExpunge(register __a6 struct LhaBase * LibBase)
{
	BPTR SegList = NULL;
	LONG LibSize;

	LibBase->Lib.lib_Flags |= LIBF_DELEXP;
	if (LibBase->Lib.lib_OpenCnt == 0) {
		Remove((struct Node *) LibBase);
		/* really expunge: remove LibBase and freemem        */
		SegList = LibBase->SegList;
		LibSize = LibBase->Lib.lib_NegSize + LibBase->Lib.lib_PosSize;
		FreeMem((char *) LibBase - LibBase->Lib.lib_NegSize, (LONG) LibSize);
	}
	else
		LibBase->Lib.lib_Flags |= LIBF_DELEXP;

	/* return NULL or real seglist                                */
	return (SegList);
}

