/*
 *  File.c - Copyright  1994 by S.R. & P.C.
 *
 *  Created:    04 Dec 1994  10:42:31
 *  Modified:   04 Dec 1994  11:19:46
 *
 *  Make>> smake
 */

#include <clib.h>
#include "Debug.h"

#include <proto/Archive.h>
#include <archives/ArchiveClass.h>
#include <archives/TarClass.h>
#include <archives/ArchiveMethods.h>
#include <archives/TarMethods.h>

#include "Tar.h"
#include "proto/File.h"


ULONG aahm_Open(Class *Cl, Object *O, struct aahpOpen *M)
{
	if (M->ArchiveHandle->ah_Mode == MODE_OLDFILE)
		*M->Error = 0;
	else
		*M->Error = ERROR_DISK_WRITE_PROTECTED;
	return 0;
}


static LONG Readable(LONG Pos, LONG Len, LONG BytesToRead)
{
	if (Pos > Len)
		return -1L;		// Safety. Should not happen
	else if (Pos + BytesToRead <= Len)
		return BytesToRead;
	else
		return Len - Pos;
}


ULONG aahm_Read(Class *Cl, Object *O, struct aahpRead *M)
{
	struct TarData *const Data = INST_DATA(Cl, O);
	struct TarEntry *TarEntry;
	LONG BytesToRead, Offset;

	TarEntry = INST_EntryData(Cl, M->ArchiveHandle->ah_Entry);
	BytesToRead = Readable(M->ArchiveHandle->ah_Pos, M->ArchiveHandle->ah_Entry->ae_Size, M->BytesToRead);
	if (BytesToRead > 0) {
		// Perform seek only if necessary (race condition)
		Offset = TarEntry->te_Offset + M->ArchiveHandle->ah_Pos;
		if (Offset != Data->TarPos) {
			Seek(Data->TarFH, Offset, OFFSET_BEGINNING);
			Data->TarPos = Offset;
		}
		*M->BytesRead = Read(Data->TarFH, M->Buffer, BytesToRead);
		if (*M->BytesRead > 0) {
			M->ArchiveHandle->ah_Pos += *M->BytesRead;
			Data->TarPos += *M->BytesRead;
		}
		else
			*M->Error = IoErr();
	}
	else
		*M->BytesRead = 0;		// End of file
	return 0;
}


ULONG aahm_Close(Class *Cl, Object *O, struct aahpClose *M)
{
	return 0;
}

