/*
 *  TarList.c - Copyright  1994 by S.R. & P.C.
 *
 *  Created:    06 Jun 1994  19:42:46
 *  Modified:   30 Nov 1994  22:50:36
 *
 *  Make>> sc <file>.c
 *  Make>> slink LIB:cs.o <file>.o SC SD ND BATCH NOICONS TO <file> LIB LIB:c.lib LIB:sc.lib
 */

#include <clib.h>

// Startup Modules...
CliArgs;

char *Template = "File/A";


#define HEADERSIZE 512
#define NAMESIZE 100
#define TUNAMELEN 32
#define TGNAMELEN 32

struct Header {
	char FileName[NAMESIZE];
	char Mode[8];
	char UID[8];
	char GID[8];
	char Size[12];				/* in octal  */
	char mtime[12];
	char CheckSum[8];
	char LinkFlag;
	char Archive_LinkName[NAMESIZE];
	char Magic[8];
	char UserName[TUNAMELEN];
	char GroupName[TGNAMELEN];
	char DevMajor[8];
	char DevMinor[8];
};


ULONG OctToL(UBYTE *Octal, UBYTE Len)
{
	UBYTE Buf[20];
	int n;

	// skip leading spaces
	while (Len && *Octal == ' ') {
		Len--;
		Octal++;
	}
	memcpy(Buf, Octal, Len);
	Buf[Len] = 0;
	stco_i(Buf, &n);
	return (ULONG) n;


/*  this has bug with big number
   USHORT OctLen;
   ULONG n = 0;
   register SHORT i;

   OctLen = strlen( s);

   while ( s[ OctLen -1] == ' ')
   OctLen--;

   if ( OctLen <= 0)
   {
   Printf("Error in hex number");
   return -1;
   }
   for (i = 0; i < OctLen; i++)
   n += ( s[ (OctLen - 1) - i]- '0') << (i * 3);

   return n;
 */
}


long Main(char *argv[], struct WBStartup *WBenchMsg)
{
	BPTR TarFile;

	if (TarFile = Open(argv[0], MODE_OLDFILE)) {
		struct Header *Header;
		char Buffer[HEADERSIZE];
		LONG BytesRead;

		Header = (struct Header *) Buffer;
		while ((BytesRead = Read(TarFile, Buffer, HEADERSIZE)) == HEADERSIZE) {
			ULONG FileSize;

			if (!Header->FileName[0])
				break;
			FileSize = OctToL(Header->Size, 12);
			Printf("%-8ld  %s\n", FileSize, Header->FileName);

			FileSize = ((FileSize + 511) / 512) * 512;	/* round up to higher block */
			Seek(TarFile, FileSize, OFFSET_CURRENT);

			//Printf("Old Position: %ld\n", Seek(TarFile, FileSize, OFFSET_CURRENT));

			if (SetSignal(0, SIGBREAKF_CTRL_C) & SIGBREAKF_CTRL_C)
				break;
		}
		Printf("End\n");
		Close(TarFile);
	}
	return 0L;
}

