/*
 *  MakeArcDesc.c - Copyright  1994 by S.R. & P.C.
 *
 *  Created:    05 Dec 1994  20:32:22
 *  Modified:   05 Dec 1994  20:44:41
 *
 *  Make>> rx BumpRev MakeArcDesc 1 0
 *  Make>> sc <file>.c
 *  Make>> slink LIB:cs.o <file>.o SC SD ND BATCH NOICONS TO <file> LIB LIB:c.lib
 */

#include <archives/ArchiveClass.h>
#include <clib.h>
#include "MakeArcDesc_rev.h"

// Startup Modules...
CliArgs; 

char *Template = "FileName/A,ObjectName/A,FileType/A";
char *CliHelp = VERS" ("DATE") [32m S. Rougier, P. Carrette, JB. Yunes, B. Lecun.[31m";

#define ARG_FILENAME	0
#define ARG_OBJNAME		1
#define ARG_FILETYPE	2


long Main(char *argv[], struct WBStartup *WBenchMsg)
{
	struct ArchiveType ArchiveType;
	struct Library *IFFParseBase;
	struct IFFHandle *iff;
	long rc = 10;

	if (!(IFFParseBase = OpenLibrary("iffparse.library", 37)))
		return 20;
	memset(&ArchiveType, 0, sizeof(struct ArchiveType));
	strcpy(ArchiveType.ObjectBaseName, argv[ARG_OBJNAME]);
	strcpy(ArchiveType.FileTypeName, argv[ARG_FILETYPE]);
	
	if (iff = AllocIFF()) {
		if (iff->iff_Stream = Open(argv[ARG_FILENAME], MODE_NEWFILE)) {
			InitIFFasDOS(iff);
			if (OpenIFF(iff, IFFF_WRITE) == 0) {
				if (PushChunk(iff, ID_ARCV, ID_FORM, IFFSIZE_UNKNOWN))
					goto Error;
				if (PushChunk(iff, ID_ARCV, ID_ARCT, IFFSIZE_UNKNOWN))
					goto Error;
				if (WriteChunkBytes(iff, &ArchiveType, sizeof(ArchiveType)) <= 0)
					goto Error;
				if (PopChunk(iff))		// Pop 'ARCT'
					goto Error;
				if (PopChunk(iff))		// Pop 'FORM'
					goto Error;
				rc = 0;
Error:
				CloseIFF(iff);
			}
			Close(iff->iff_Stream);
		}
		else
			PrintFault(IoErr(), "MakeArcDesc");
		FreeIFF(iff);
	}
	CloseLibrary(IFFParseBase);
	return rc;
}

