/*
 *  MountArchive.c - Copyright  1994 by S.R. & P.C.
 *
 *  Created:    18 Nov 1994  01:35:36
 *  Modified:   07 Dec 1994  12:51:50
 *
 *  Make>> rx BumpRev MountArchive 1 1
 *  Make>> sc <file>.c
 *  Make>> slink LIB:cs.o <file>.o SC SD BATCH NOICONS TO <file> LIB LIB:c.lib
 */

#include <clib.h>
#include <archives/archiveclass.h>
#include <proto/archive.h>
#include "MountArchive_rev.h"

// Startup Modules...
WorkbenchStartup; CliArgs;

static char Version[] = VERSTAG;

char *Template = "Name/A,ShowDev/S";
char *CliHelp = VERS" ("DATE") [32m S. Rougier, P. Carrette, JB. Yunes, B. Lecun.[31m";

#define ARG_NAME		0
#define ARG_SHOWDEV		1

long Main(char *argv[], struct WBStartup *WBenchMsg)
{
	struct Library *ArchiveBase;
	char *Name, DeviceName[40];
	BPTR CD = NULL;
	long rc = 20;

	if (WBenchMsg) {
		if (WBenchMsg->sm_NumArgs > 1) {
			CD = CurrentDir(WBenchMsg->sm_ArgList[1].wa_Lock);
			Name = WBenchMsg->sm_ArgList[1].wa_Name;
		}
		else
			return 0;
	}
	else
		Name = argv[ARG_NAME];
	if (ArchiveBase = OpenLibrary("archive.library", 1L)) {
		BPTR ArcVolumeLock;

		if (ArcVolumeLock = MountArchive(Name, MA_DeviceName, DeviceName, TAG_END)) {
			UnLock(ArcVolumeLock);
			if (Cli() && argv[ARG_SHOWDEV])
				Printf("%s\n", DeviceName);
			rc = 0;
		}
		else
			PrintFault(IoErr(), "MountArchive");
		CloseLibrary(ArchiveBase);
	}
	else
		Printf("Failed to open archive.library v1\n");
	if (CD)
		CurrentDir(CD);
	return rc;
}

