#include <exec/types.h>
#include <exec/devices.h>
#include <exec/errors.h>
#include <exec/execbase.h>
#include <exec/memory.h>
#include <dos/dos.h>
#include <dos/dosextens.h>
#include <dos/filehandler.h>
#include <utility/tagitem.h>
#include <dos/dostags.h>
#include <proto/exec.h>
#include <proto/dos.h>
#include <proto/expansion.h>
#include <stdio.h>
#include <string.h>

char	*ToBStr(char *);

struct DosLibrary	*DosBase;
struct Library		*ExpansionBase;
struct MyStartup {
	struct MsgPort	*ms_Port;
};

void main()
{
struct MsgPort			*my_port;
struct DeviceNode		*devicenode;
struct Process			*handlerprocess;
struct TagItem			tags[10];
struct MyStartup		*startup;

	fprintf(stderr,"coucou\n");
	DosBase = (struct DosLibrary *) OpenLibrary(DOSNAME,LIBRARY_MINIMUM);
	if (DosBase==NULL) {
		printf("Sorry cannot open %s\n",DOSNAME);
		return;
	}
	ExpansionBase = OpenLibrary("expansion.library",37L);
	if (ExpansionBase==NULL) {
		printf("sorry cannot open expansion.library\n");
		CloseLibrary(DosBase);
		return;
	}

	my_port =  &((struct Process *)FindTask(NULL))->pr_MsgPort;

	devicenode = (struct DeviceNode *)AllocVec(sizeof(struct DeviceNode),
			MEMF_CHIP|MEMF_CLEAR);
	if (devicenode==NULL) {
		printf("cannot allocate bytes\n");
		return;
	}
	devicenode->dn_Next = NULL;
	devicenode->dn_Type = DLT_DEVICE;
	devicenode->dn_Task = NULL;
	devicenode->dn_Lock = NULL;
	devicenode->dn_Handler = (BSTR)MKBADDR(ToBStr("L:Handler"));
	devicenode->dn_StackSize = 20000;
	devicenode->dn_Priority = 4;
	startup = (struct MyStartup *)AllocVec(
		sizeof(struct MyStartup),MEMF_CHIP|MEMF_CLEAR);
	if (startup!=NULL) {
		startup->ms_Port = my_port;
	}
	devicenode->dn_Startup = (BPTR)MKBADDR(startup);
	devicenode->dn_SegList = NULL;
	devicenode->dn_GlobalVec = -1;
	devicenode->dn_Name = (BSTR)MKBADDR(ToBStr("JBY"));

	/*if (AddDosNode(-128,ADNF_STARTPROC,devicenode))*/
	if (AddDosNode(-128,1,devicenode))
		printf("OK\n");
	else
		printf("BAD\n");

	CloseLibrary(ExpansionBase);
	CloseLibrary((struct Library *)DosBase);
}

char	*ToBStr(char *string)
{
char	*t;
int	l;

	l = strlen(string);
	t = AllocVec(l+1+1,MEMF_CLEAR|MEMF_CHIP);
	if (t!=NULL) {
		strcpy(t+1,string);
		t[0] = (char)l;
	}
	return t;
}
